/*10:*/
#line 233 "kNN_MDS.w"

/*41:*/
#line 2173 "kNN_MDS.w"

#include <iostream> 
#include <cstdio> 
#include <memory> 
#include <string> 
#include <time.h> 
#include <fstream> 
#include "math.h"
#include "matrix.h"

using namespace std;

/*:41*/
#line 234 "kNN_MDS.w"

/*40:*/
#line 2018 "kNN_MDS.w"


#define REAL double 
//#define REAL float // The data type of samples 
#define LP 2  
#define DIS L2dis     
//#define DIS L1dis     // $L_1$ distance 
//#define DIS Linfdis   // $L_\infty$ distance  
#define DIS2 L2dis2     
//#define DIS2 L1dis2     // Squared distance. Active one corresponding to 
//#define DIS2 Linfdis2     // Squared distance. Active one corresponding to 

const REAL EPS= 1.e-10;
YESNO do_orthonormal= NO;

int sampling_ceil= 1000;
float tail_percentage= 10.0;
float cut_off= tail_percentage/100.0;


int dflag= 0;
int qflag= 1;
int pflag= 1;
int tflag= 0;
int rflag= 0;
int allpca_flag= 0;

int sampled_eigen_flag= 0;
int ocflag= 0;


int PCAdim= 10;
int qdim= 10;
int qsdim= 0;
int q= qdim;
float eta= 0.0;
int K= 1;
int kk= K;
int nc= 1;


int std_in_flag= 0;
int uflag= 0;


int A= 1;

const int kNNoutput= 1;


const int KMAX= 1000;
const int CLASS= 256;
const int DATAMAX= 150000;
const int DIMMAX= 10000;
const int FMAX= DIMMAX;
const int LINEMAX= 65000;
const int Max_Line= LINEMAX;
const int BISECMAX= 100;

const int max_checked_rank= 5;

const int BS_FLAG= 1;

const int B_default= 100;

enum Narrowing{Nothing= 0,Filtering= 1,Binary_Search= 2,Table_Lookup= 3};

enum Narrowing narrow= Filtering;

typedef struct cell{
int id;
int rid;
REAL val;
}CELL;

REAL c1= 3.0;
REAL c2= 3.0;

int checked_rank= max_checked_rank;

long*reject_count;

FILE*fp_tr;
FILE*fp_te;
FILE*fp_tmp;

char*file_tr;
char*file_te;
char*file_in;

int n_tr= 0;
int n_te= 0;

int n;
int m;
int n_fea;

int tr_pc[CLASS];
int te_pc[CLASS];

int ncorrect;
int nwrong;

char line[LINEMAX];
char w[DIMMAX][50];

REAL p[CLASS];
int conf_matrix[CLASS][CLASS+1];

REAL**trx;
REAL**te_data;
REAL**pdis2;
REAL*tr_norm;
REAL xnorm;
REAL*zero;


int tr_flag= 0;
int te_flag= 0;
int p_flag= 0;
int texflag= 0;

int testflag= 0;
REAL Default_max_nn= 1.e10;
int level= 0;
REAL costsum;
REAL ans;
int nn_fea= 0;


REAL*var;
char*ver= "(1.3)";

int S= 10000;
int topS;
int switch_bisector= 0;
int switch_ball= 0;

int updated= 0;

REAL*disbset;
int*bestp;

REAL current_d= 1.e50;
REAL current_db= current_d;
int current_p= (-1);
int current_pb= (-1);
REAL e;

static char*in_file= "ModelFile";
static char*out_file= "ModelFile";
int model_in_flag= 0;
int model_out_flag= 0;

/*:40*/
#line 235 "kNN_MDS.w"

/*33:*/
#line 1285 "kNN_MDS.w"

#define max(x,y) ( (x) >  (y) ? (x) : (y) )
#define min(x,y) ( (x) < (y) ? (x) : (y) )
#define abs(x) ( (x) >  0.0 ? (x) : (-(x)) )
int getword_of_line(FILE*fp,char*line,char word[][50],int max);


inline REAL L2dis(REAL*a,REAL*b)
{
REAL sum= 0.0;
REAL diff;
for(int i= 0;i<m;i++)
{
diff= a[i]-b[i];
sum+= diff*diff;
}

return sqrt(sum);
}

inline REAL L2dis2(REAL*a,REAL*b)
{
REAL sum= 0.0;
REAL diff;
for(int i= 0;i<m;i++)
{
diff= a[i]-b[i];
sum+= diff*diff;
}

return sum;
}

inline REAL L2dis2(ColumnVector&a,ColumnVector&b)
{
REAL sum= 0.0;
REAL diff;
for(int i= 0;i<m;i++)
{
diff= a(i)-b(i);
sum+= diff*diff;
}

return sum;
}

inline REAL L2dis2(int k,int l)
{
REAL sum= 0.0;
REAL diff;
for(int i= 0;i<m;i++)
{
diff= trx[k][i]-trx[l][i];
sum+= diff*diff;
}

return sum;
}


inline REAL L1dis(REAL*a,REAL*b)
{
REAL sum= 0.0;
REAL diff;
for(int i= 0;i<m;i++)
{
diff= a[i]-b[i];
sum+= abs(diff);
}

return sum;
}

inline REAL L1dis2(REAL*a,REAL*b)
{
return L1dis(a,b);
}

inline REAL L1dis2(ColumnVector&a,ColumnVector&b)
{
REAL sum= 0.0;
REAL diff;
for(int i= 0;i<m;i++)
{
diff= a(i)-b(i);
sum+= abs(diff);
}

return sum;
}

inline REAL L1dis2(int k,int l)
{
return L1dis(trx[k],trx[l]);
}


inline REAL Linfdis(REAL*a,REAL*b)
{
REAL sum= 1.e-50;
REAL diff;
for(int i= 0;i<m;i++)
{
diff= a[i]-b[i];
sum= max(sum,abs(diff));
}
return sum;
}

inline REAL Linfdis2(REAL*a,REAL*b)
{
return Linfdis(a,b);
}

inline REAL Linfdis2(ColumnVector&a,ColumnVector&b)
{
REAL sum= 1.e-50;
REAL diff;
for(int i= 0;i<m;i++)
{
diff= a(i)-b(i);
sum= max(sum,abs(diff));
}
return sum;
}

inline REAL Linfdis2(int k,int l)
{
return Linfdis(trx[k],trx[l]);
}


inline REAL innerp(REAL*a,REAL*b)
{
REAL sum= 0.0;

for(int i= 0;i<m;i++)
sum+= a[i]*b[i];

return sum;
}

inline REAL innerp(ColumnVector&a,ColumnVector&b)
{
REAL sum= 0.0;

for(int i= 0;i<m;i++)
sum+= a(i)*b(i);

return sum;
}

inline REAL norm(REAL*a)
{
REAL sum= 0.0;
for(int i= 0;i<m;i++)
sum+= a[i]*a[i];

return sqrt(sum);
}


REAL stock_k_nn(int k,REAL entry,int entry_no,int*ono,REAL*ostock,
int set_flag= 0,int init_flag= 0)







{
static int cc= 0;
static REAL*stock= 0;
static int*no;
static int num= 0;


if(cc==0)
{
try{
stock= new REAL[k+1];
for(int i= 0;i<k;i++)
stock[i]= 1.e33;
no= new int[k+1];
}
catch(bad_alloc){
cerr<<"Cannot alloc memory for stock and no "<<endl;
exit(0);
}
}

if(cc==0||init_flag!=0)
{
for(int i= 0;i<k;i++)
stock[i]= 1.e33;
for(int i= 0;i<k;i++)
no[i]= (-1);
num= 0;
cc++;
return stock[k-1];
}

if(set_flag)
{
for(int i= 0;i<k;i++)
{
ostock[i]= stock[i];
ono[i]= no[i];
}
return ostock[k-1];
}

cc++;
num++;


if(k==1)
{
if(entry<stock[0])
{
stock[0]= entry;
no[0]= entry_no;
}
}
else
{
stock[k]= entry;
no[k]= entry_no;

REAL tmp;
int tmpi;

for(int i= k-1;i>=0;i--)
{
if(stock[i]> stock[i+1])
{
tmp= stock[i];
stock[i]= stock[i+1];
stock[i+1]= tmp;
tmpi= no[i];
no[i]= no[i+1];
no[i+1]= tmpi;
}
else
break;
}
}


#ifdef DEBUG
printf("Answer for %d data: ",num);
for(int i= 0;i<k;i++)
printf("(%d, %f) ",no[i],stock[i]);
printf("\n");fflush(stdout);
#endif

return stock[k-1];

}

inline REAL find_k_nn_in_training(int k,int about,int n,REAL**tr,int*kno,REAL*kdis)
{
stock_k_nn(k,0.0,0,kno,kdis,0,1);
REAL d;
for(int i= 0;i<n;i++)
{
if(i==about)
continue;
d= DIS2(about,i);
stock_k_nn(k,d,i,kno,kdis);
}
stock_k_nn(k,0.0,0,kno,kdis,1);

return kdis[k-1];

}

inline int comp_score(const void*p1,const void*p2)
{
CELL*s1= (CELL*)p1;
CELL*s2= (CELL*)p2;
double v= s1->val-s2->val;
if(v> 0.)
return 1;
else if(v<0.)
return(-1);
else
return 0;
}


/*:33*//*49:*/
#line 2281 "kNN_MDS.w"

int class_from_num(int ii,int*trnum,int cn)
{
int cl= 0;
int tnum,j;
int i= ii;
while((i-= trnum[cl])>=0)
{
cl++;
}

if(ii<0||cl>=cn)
{
tnum= 0;
for(j= 0;j<cn;j++)
tnum+= trnum[cl];

fprintf(stderr,"*E* number %d is over %d of stored samples cl=%d cn=%d (trnum[%d]=%d)\n",
ii,tnum,cl,cn,cl,trnum[cl]);
fflush(stderr);
exit(0);
}

return cl;
}

/*:49*//*50:*/
#line 2308 "kNN_MDS.w"

int output(int k,int*knn_id,REAL*knn_dis,int tn)
{
static int cc= 0;
static int*num;

if(cc==0)
num= new int[nc];

for(int i= 0;i<nc;i++)
num[i]= 0;

int cl;
for(int i= 0;i<k;i++)
{
cl= class_from_num(knn_id[i],tr_pc,nc);
num[cl]++;
}


int maxc= (-1);
int maxv= (-1);
for(int i= 0;i<nc;i++)
{
if(num[i]> maxv)
{
maxv= num[i];
maxc= i;
}
}


REAL v= 0.0;
int vc= 0;
int first;
for(int i= 0;i<k;i++)
if(class_from_num(knn_id[i],tr_pc,nc)==maxc)
{
v+= knn_dis[i];
vc++;
}

first= knn_id[0];

if(vc> 0)
v/= (REAL)vc;

if(ocflag)
{
printf("OUT  %d %f %d\n",maxc,v,first);
fflush(stdout);
}

int tcl;
if(!std_in_flag)
tcl= class_from_num(tn,te_pc,nc);
else
tcl= (-1);

#ifdef DEBUG
printf("* %s * Test sample %d (class %d) is assigned to class %d with value %f\n",
(maxc==tcl)?"Correct":"Wrong",tn,tcl,maxc,v);
#endif

if(maxc==tcl)
ncorrect++;
else
nwrong++;

cc++;

return maxc;
}


/*:50*//*72:*/
#line 3203 "kNN_MDS.w"

REAL estimated_reduction(int n,int m,int l,REAL delta)
{
REAL r;

r= 1.0-delta+REAL(l)/m+c2*REAL(l)/c1/REAL(n);

return r;
}


/*:72*/
#line 236 "kNN_MDS.w"

/*11:*/
#line 240 "kNN_MDS.w"


int main(int argc,char**argv)
{

cout<<"--(1)-- Environmental setting "<<endl;

/*37:*/
#line 1731 "kNN_MDS.w"

if(argc<3)
{
/*39:*/
#line 1984 "kNN_MDS.w"

printf("< Usage of %s (ver. %s) as of %s > %s training-file\
 test-file [-k k[%d]][-c c[%d]][-tr n1 n2 ... nc][-te m1 m2 ... mc][-A select_number [%d]]\
[-Q q(marginal dimension [%d])[-E eta][-P][-NP][-T][-NT][-R][-NR][-S sampling_no]\
[-O(ut) Modelfile][-I(n) ModelFile][-F filter-mode][-u][-z cut-off][-f]\n",
argv[0],ver,__DATE__,argv[0],K,nc,A,qdim);
printf("\t -k k .... the number of nearest neighbors [Default : %d] \n",K);
printf("\t -c c ....  the number of classes [Default : %d] \n",nc);
printf("\t -tr n1 .... nc: the numbers of training samples in class order\
 [Default : equally]\n");
printf("\t -te m1 .... mc: the numbers of testing samples in class order\
 [Default : equally]\n");
printf("\t -A [%d] ... error level (-1): interactive choice, 0:0%, 1:0.1%, 2:0.5%, \
3:1%, 4:5%, 5:10%\n",A);
printf("\t -Q q .... the maximum dimension of marginal distance strategy [Default %d] \n",
qdim);
printf("\t -E eta .... approximate nearest neighbor of (1+eta) times the nearest negihbor distance [Defalt %f] \n",eta);
printf("\t -L q .... the user specified dimension of marginal distance\
 strategy [Default %d] \n",qsdim);
printf("\t -z cut-off .... the probability of error nearest neighbor [Default %f \%] \n",
tail_percentage);
printf("\t -P or -NP .... : use or not of the partial distance strategy [Default %s] \n",
(pflag)?"ON":"OFF");
printf("\t -T or -NT .... : use or not of the termination criterion [Default %s] \n",
(tflag)?"ON":"OFF");
printf("\t -R or -NR .... : use or not of the recovery process for irregularly\
 large kNN [Default %s]\n",
(rflag)?"ON":"OFF");
printf("\t -S s ...: the maximum number of sampling points [Default %d] \n",sampling_ceil);
printf("\t -F fmode ... 0: Nothing, 1:Filtering, 2:Binary_search, 3: Table-lookup [%d]\n",narrow);
printf("\t\t *Warning* if you choose 2 or more, then 0.1%% error is added.\n");
printf("\t -f ...: fast calculation of eigen vectors using sampled points [Default %d] \n",sampled_eigen_flag);

/*:39*/
#line 1734 "kNN_MDS.w"

exit(0);
}

file_tr= argv[1];

if((fp_tr= fopen(argv[1],"r"))==NULL)
{
printf(" * training file < %s > open error * \n",argv[1]);
exit(0);
}

argc--;
argv++;

if(argv[1][0]!='-')
{
file_te= argv[1];
argc--;
argv++;

}
else
{
std_in_flag= 1;
argc--;
argv++;
}


char c;
while(--argc&&(*++argv)[0]=='-')
{
switch(c= *++argv[0])
{

case'p':
printf(" A priori probabilities are : ");
for(int i= 0;i<nc;i++)
{
p[i]= atof(*++argv);--argc;
printf(" %f",p[i]);
}
putchar('\n');
p_flag= 1;
break;

case'Q':
q= qdim= atoi(*++argv);--argc;
printf("(Option) the maximum dimension of marginal distance was set to %d\n",qdim);
break;

case'L':
qsdim= atoi(*++argv);--argc;
printf("(Option) the dimension of marginal distance was set to %d\n",qsdim);
break;

case'E':
eta= atof(*++argv);--argc;
printf("(Option) approximation degree eta was set to %f\n",eta);
break;

case'P':
pflag= 1;
printf("(Option) use of partial distance strategy\n");
break;

case'R':
rflag= 1;
printf("(Option) use of recovery process for irregularly large kNN\n");
break;

case'T':
tflag= 1;
printf("(Option) use of termination strategy\n");
break;

case'N':
switch(c= *++argv[0])
{
case'P':
pflag= 0;
printf("(Option) no use of partial distance strategy\n");
break;

case'R':
rflag= 0;
printf("(Option) no use of recovery process for irregularly large kNN\n");
break;

case'T':
tflag= 0;
printf("(Option) no use of termination strategy\n");
break;

default:
break;
}
break;

case't':
switch(c= *++argv[0])
{
case'r':
printf(" Training sample numbers are : ");
for(int i= 0;i<nc;i++)
{
tr_pc[i]= atoi(*++argv);--argc;
printf(" %d",tr_pc[i]);
}
putchar('\n');
tr_flag= 1;
break;

case'e':
printf(" Test sample numbers are : ");
for(int i= 0;i<nc;i++)
{
te_pc[i]= atoi(*++argv);--argc;
printf(" %d",te_pc[i]);
}
putchar('\n');
te_flag= 1;
break;

default:
printf("*error* no option as -t%c \n",c);
exit(0);
break;
}
break;

case'u':
uflag= 1;
break;

case'k':
K= kk= atoi(*++argv);--argc;
if(kk> KMAX)
{
fprintf(stderr,"* error *  number %d over max %d \n",kk,KMAX);
exit(0);
}
break;

case'S':
sampling_ceil= atoi(*++argv);--argc;
printf("* sampling_ceil was set to %d \n",sampling_ceil);
break;

case'A':
A= atoi(*++argv);--argc;
printf("* A was set to %d \n",A);
break;

case'F':
narrow= Narrowing(atoi(*++argv));--argc;
printf("* narrow was set to %d \n",narrow);
break;

case'z':
tail_percentage= atof(*++argv);--argc;
cut_off= tail_percentage/100.0;
printf(" Cut_off (the probability of error nearest neighbor) was set to %f \n",cut_off);
break;

case'C':
topS= atoi(*++argv);--argc;
printf(" topS was set in option to %d\n",topS);
break;

case'b':
switch_bisector= 1;
printf(" Bisectors will be used for narrowing the candidate region \n");
break;

case'a':
switch_ball= 1;
printf(" Balls will be used for narrowing the candidate region \n");
break;

case'm':
Default_max_nn= atof(*++argv);--argc;
printf(" Max_nn was set to %f \n",Default_max_nn);
break;

case'O':
out_file= *++argv;--argc;
model_out_flag= 1;
printf("Out_file was set to %s \n",out_file);
break;

case'I':
in_file= *++argv;--argc;
model_in_flag= 1;
printf("Model_in_file was set to %s \n",in_file);
break;

case'c':
nc= atoi(*++argv);--argc;
printf("Class number is set to %d \n",nc);
if(nc> CLASS)
{
fprintf(stderr,"* error * class number %d over max %d \n",c,CLASS);
exit(0);
}
break;

case'f':
sampled_eigen_flag= 1;
break;

case'h':
cout<<"with h"<<endl;
/*39:*/
#line 1984 "kNN_MDS.w"

printf("< Usage of %s (ver. %s) as of %s > %s training-file\
 test-file [-k k[%d]][-c c[%d]][-tr n1 n2 ... nc][-te m1 m2 ... mc][-A select_number [%d]]\
[-Q q(marginal dimension [%d])[-E eta][-P][-NP][-T][-NT][-R][-NR][-S sampling_no]\
[-O(ut) Modelfile][-I(n) ModelFile][-F filter-mode][-u][-z cut-off][-f]\n",
argv[0],ver,__DATE__,argv[0],K,nc,A,qdim);
printf("\t -k k .... the number of nearest neighbors [Default : %d] \n",K);
printf("\t -c c ....  the number of classes [Default : %d] \n",nc);
printf("\t -tr n1 .... nc: the numbers of training samples in class order\
 [Default : equally]\n");
printf("\t -te m1 .... mc: the numbers of testing samples in class order\
 [Default : equally]\n");
printf("\t -A [%d] ... error level (-1): interactive choice, 0:0%, 1:0.1%, 2:0.5%, \
3:1%, 4:5%, 5:10%\n",A);
printf("\t -Q q .... the maximum dimension of marginal distance strategy [Default %d] \n",
qdim);
printf("\t -E eta .... approximate nearest neighbor of (1+eta) times the nearest negihbor distance [Defalt %f] \n",eta);
printf("\t -L q .... the user specified dimension of marginal distance\
 strategy [Default %d] \n",qsdim);
printf("\t -z cut-off .... the probability of error nearest neighbor [Default %f \%] \n",
tail_percentage);
printf("\t -P or -NP .... : use or not of the partial distance strategy [Default %s] \n",
(pflag)?"ON":"OFF");
printf("\t -T or -NT .... : use or not of the termination criterion [Default %s] \n",
(tflag)?"ON":"OFF");
printf("\t -R or -NR .... : use or not of the recovery process for irregularly\
 large kNN [Default %s]\n",
(rflag)?"ON":"OFF");
printf("\t -S s ...: the maximum number of sampling points [Default %d] \n",sampling_ceil);
printf("\t -F fmode ... 0: Nothing, 1:Filtering, 2:Binary_search, 3: Table-lookup [%d]\n",narrow);
printf("\t\t *Warning* if you choose 2 or more, then 0.1%% error is added.\n");
printf("\t -f ...: fast calculation of eigen vectors using sampled points [Default %d] \n",sampled_eigen_flag);

/*:39*/
#line 1948 "kNN_MDS.w"

exit(0);
break;

default:
fprintf(stderr," * Error * Such an option does not exist ! .. %c \n",c);
exit(0);
break;

}
}

/*38:*/
#line 1976 "kNN_MDS.w"

if(A==0)
allpca_flag= rflag= q= 0;

if(nc==0||kk> 0)
tflag= 0;

/*:38*/
#line 1960 "kNN_MDS.w"


printf("(Option flags) pflag=%d tflag=%d rflag=%d allpca_flag=%d q=%d A=%d\n",
pflag,tflag,rflag,allpca_flag,q,A);

printf("*Nearest neighbor number is set to K=%d \n",kk);
printf("*Narrowing : %d \n",int(narrow));

if(A==0)
{
printf("* Exact search was chosen with A=%d \n",A);
q= 1;
narrow= Nothing;
}

/*:37*/
#line 247 "kNN_MDS.w"
;








CELL*pair= NULL;

int*iri;

if(model_in_flag)
{
cout<<"--(1.1a)-- Reading of sorted data index "<<endl;
/*85:*/
#line 3493 "kNN_MDS.w"

{
FILE*fp;
char ifile[256];
sprintf(ifile,"%s_sorted_index",in_file);
if((fp= fopen(ifile,"r"))==NULL)
{
fprintf(stderr," * file <%s> open error * \n",ifile);
exit(0);
}

fscanf(fp,"n= %d m= %d\n",&n,&m);
printf("From Indexfile <%s>: n=%d m=%d\n",ifile,n,m);
fflush(stdout);
pair= new CELL[n];

for(int i= 0;i<n;i++)
fscanf(fp,"%d %d %lf\n",&pair[i].rid,&pair[i].id,&pair[i].val);

fclose(fp);


}














/*:85*/
#line 263 "kNN_MDS.w"

iri= new int[n];
for(int i= 0;i<n;i++)
iri[i]= pair[i].rid;
}


cout<<"--(1.1)-- Reading of the training data "<<endl;
/*35:*/
#line 1605 "kNN_MDS.w"

char line[Max_Line];
char word[Max_Line][50];
FILE*fp_tr;

int nread;

file_in= file_tr;
/*34:*/
#line 1581 "kNN_MDS.w"

{
FILE*fp_in;
if((fp_in= fopen(file_in,"r"))==NULL)
{
fprintf(stderr," * file <%s> open error * \n",file_in);
exit(0);
}
int nw;

nread= 0;

while((nw= getword_of_line(fp_in,line,word,Max_Line))!=0)
{
if(n==0)
m= nw;
nread++;
}
fclose(fp_in);


}

/*:34*/
#line 1613 "kNN_MDS.w"
;

n_tr= n= nread;

cout<<"n = "<<n<<" m = "<<m<<endl;

if((fp_tr= fopen(file_tr,"r"))==NULL)
{
fprintf(stderr," * training file <%s> open error * \n",file_tr);
exit(0);
}

try{

trx= new REAL*[n];

for(int i= 0;i<n;i++)
trx[i]= new REAL[m];

}
catch(bad_alloc)
{
cerr<<"*E* cannot allocate memory for data with n,m= "<<n<<" "<<m<<endl;
exit(0);
}


if(model_in_flag)
{
int i;
for(int ii= 0;ii<n;ii++)
{
i= iri[ii];
int nw= 0;
if((nw= getword_of_line(fp_tr,line,word,Max_Line))!=0)
{
for(int k= 0;k<nw;k++)
trx[i][k]= REAL(atof(word[k]));
}
}
}
else
{
for(int i= 0;i<n;i++)
{
int nw= 0;
if((nw= getword_of_line(fp_tr,line,word,Max_Line))!=0)
{
for(int k= 0;k<nw;k++)
trx[i][k]= REAL(atof(word[k]));
}
}
}

fclose(fp_tr);


/*:35*/
#line 271 "kNN_MDS.w"
;

n_tr= n;
if(!tr_flag)
/*16:*/
#line 716 "kNN_MDS.w"

{
printf("\n * Wmmm ... < Training Sample >set equivalent samples for each\
 class by %d \n",n_tr/nc);
fflush(stdout);
for(int i= 0;i<nc;i++)
tr_pc[i]= n_tr/nc;
}

/*:16*/
#line 275 "kNN_MDS.w"
;

cout<<"--(1.2)-- Find the empirical dist."<<endl;
/*15:*/
#line 678 "kNN_MDS.w"


if(m<=PCAdim&&n> m)
/*18:*/
#line 739 "kNN_MDS.w"

{
printf("\n * Because of small dimensions %d <= %d, we transform all data by PCA\n",
m,PCAdim);
allpca_flag= 1;
}

/*:18*/
#line 681 "kNN_MDS.w"


/*19:*/
#line 747 "kNN_MDS.w"









int*NN;
int*NNhalf;
int select_level;
REAL*thresh_l= new REAL[q+1];
REAL thresh_1st;

/*:19*//*20:*/
#line 763 "kNN_MDS.w"












Matrix X(m,n);
ColumnVector M(m);
Matrix Cov(m,m);
Matrix Eval(m,m);
Matrix Evec(m,m);

/*:20*//*21:*/
#line 782 "kNN_MDS.w"








ColumnVector PV(m);
Matrix PX(q,n);
if(allpca_flag)
PX= Matrix(m,n);

REAL**ptrx;

/*:21*//*22:*/
#line 798 "kNN_MDS.w"








int n_sampling;
int sampling_skip= 1;
int n_tail;

/*65:*/
#line 2742 "kNN_MDS.w"

{
n_sampling= min(n,sampling_ceil);

int on_sampling= n_sampling;

sampling_skip= 1;
if(n> n_sampling)
sampling_skip= (n%n_sampling==0)?n/n_sampling:int(REAL(n)/REAL(n_sampling));

if(n%sampling_skip!=0)
n_sampling= n/sampling_skip+1;

printf("For n=%d and n_sampling =%d ... sampling_skip =%d n_sampling =%d\n",
n,on_sampling,sampling_skip,n_sampling);

n_tail= int(tail_percentage*0.01*n_sampling)+1;
n_tail= min(n_tail,n);

cout<<"Set of sampling n_sampling = "<<n_sampling<<" with sampling_skip = "<<
sampling_skip<<endl;

cout<<"n_sampling= "<<n_sampling<<endl;
Matrix SX(m,n_sampling+1);
Matrix PSX(q,n_sampling+1);

}

/*:65*/
#line 810 "kNN_MDS.w"


Matrix SX(m,n_sampling+1);
Matrix PSX(q,n_sampling+1);

/*:22*//*23:*/
#line 816 "kNN_MDS.w"













Matrix XNtail(n_tail,q+1);
static int n_error_level= 6;
REAL error_level[]= {0.0,0.1,0.5,1.0,5.0,10.0};
REAL**gain= new REAL*[n_error_level];
REAL**threshold= new REAL*[n_error_level];
for(int i= 0;i<n_error_level;i++)
{
gain[i]= new REAL[q+1];
threshold[i]= new REAL[q+1];
gain[i][0]= 0.0;
}

Matrix P(n_tail+1,q+1);

REAL*TermR2;
REAL**ev;
REAL*px;

/*:23*/
#line 683 "kNN_MDS.w"


if(!model_in_flag)
{
/*64:*/
#line 2709 "kNN_MDS.w"

{
ColumnVector x(m);
int cc= 0;

#ifdef DEBUG
cout<<"X: rows="<<X.Nrows()<<" cols="<<X.Ncols()<<endl;
cout<<"SX: rows="<<SX.Nrows()<<" cols="<<SX.Ncols()<<endl;
#endif

for(int i= 0;i<n;i++)
{
for(int j= 0;j<m;j++)
x(j)= trx[i][j];

X.SetCols(i,i,x);

if((i%sampling_skip)==0&&cc<n_sampling)
{
SX.SetCols(cc,cc,x);
cc++;
}

}
if(cc!=n_sampling)
{
cerr<<"*Sampling is strange in SX setting"<<endl;
cerr<<"cc = "<<cc<<" n_sampling = "<<n_sampling<<endl;
exit(0);
}
}

/*:64*/
#line 687 "kNN_MDS.w"


/*26:*/
#line 920 "kNN_MDS.w"

{
int n_exam= 0;

REAL p_mean;
REAL p_var;

/*27:*/
#line 1021 "kNN_MDS.w"

{

int n_pair_sampling= n_sampling*(n_sampling-1)/2;
ColumnVector D(n_pair_sampling);

int nn= sampling_skip*n_sampling;

int cc= 0;
for(int i= 0;i<nn;i+= sampling_skip)
for(int j= i+sampling_skip;j<nn;j+= sampling_skip)
D(cc++)= DIS2(i,j);

#ifdef DEBUG
cout<<"Mean = "<<D.Mean()<<endl;
cout<<"Variance = "<<D.Variance(D.Mean())<<endl;
#endif

p_mean= D.Mean();
p_var= D.Variance(D.Mean());

}

/*:27*/
#line 927 "kNN_MDS.w"


cout<<"(X,Y): Mean = "<<p_mean<<"\tVariance = "<<p_var<<endl;

REAL nn_mean;
REAL nn_var;

NN= new int[n];
if(tflag)
NNhalf= new int[n];

/*28:*/
#line 1045 "kNN_MDS.w"

{
REAL pdisq;
int cc= 0;
REAL vmin;
int nmin;
ColumnVector D(n_sampling);

Matrix DkNN;
if(kNNoutput==1)
DkNN= Matrix(n_sampling,m);

int*kno= new int[K];
REAL*kdis= new REAL[K];

cc= 0;
int nn= sampling_skip*n_sampling;

for(int i= 0;i<nn;i+= sampling_skip)
{

find_k_nn_in_training(K,i,n,trx,kno,kdis);
NN[cc]= kno[K-1];

if(kNNoutput==1)
for(int j= 0;j<m;j++)
DkNN(cc,j)= (trx[NN[cc]][j]-trx[i][j]);

D(cc++)= kdis[K-1];
if(tflag&&(nc> 1||K==1))
NNhalf[i]= kno[int((K+1)/2)];
}

delete[]kno;
delete[]kdis;

nn_mean= D.Mean();
nn_var= D.Variance(D.Mean());

if(kNNoutput==1)
{
FILE*fp;
fp= fopen("sampled_kNN","w");

Matrix DkNNM;
DkNN.Output(fp,"kNN's");
DkNNM= DkNN.t().MeanVec();
DkNNM.Print("Mean of kNN");
DkNN.t().VarianceMatrix(DkNNM).Print("Covariance matrix of kNN");

fclose(fp);
}

}

/*:28*/
#line 938 "kNN_MDS.w"


cout<<"(X,X_knn): Mean = "<<nn_mean<<"\tVariance = "<<nn_var<<endl;

#ifdef DEBUG
cout<<"In analysis: n_tail = "<<n_tail<<" for "<<tail_percentage
<<" % of "<<n_sampling<<" sampling data"<<endl;
#endif


if(q> m)
{
fprintf(stderr,"(Warning) q=%d > m=%d ... q is replaced by m=%d\n",q,m,m);
q= m;
}


REAL total_variance;
REAL ratio;

int n_sample_PCA;
if(allpca_flag)
if(sampled_eigen_flag)
{
cout<<"In fast finding eigen vectors, use only sampled data"<<endl;
/*54:*/
#line 2487 "kNN_MDS.w"

{
#ifdef DEBUG
cout<<"In calc |m| eigen values m ="<<m<<endl;
#endif




M*= 0.0;
for(int i= 0;i<n_sampling;i++)
M+= SX.Cols(i,i);
M*= 1.0/(Real)n_sampling;



Cov= SX*SX.t()*1.0/(Real)n_sampling-M*M.t();
total_variance= Cov.Tr();
cout<<"Total variance = "<<total_variance<<endl;

#ifdef DEBUG
cout<<"In> Cov.Eigen "<<endl;
#endif
ratio= Cov.Eigen(Eval,Evec,m);
n_sample_PCA= n_sampling;
}


/*:54*/
#line 963 "kNN_MDS.w"

}
else
/*53:*/
#line 2458 "kNN_MDS.w"

{
#ifdef DEBUG
cout<<"In calc |m| eigen values m ="<<m<<endl;
#endif




M*= 0.0;
for(int i= 0;i<n;i++)
M+= X.Cols(i,i);
M*= 1.0/(Real)n;



Cov= X*X.t()*1.0/(Real)n-M*M.t();
total_variance= Cov.Tr();
cout<<"Total variance = "<<total_variance<<endl;

#ifdef DEBUG
cout<<"In> Cov.Eigen "<<endl;
#endif
ratio= Cov.Eigen(Eval,Evec,m);
n_sample_PCA= n;
}


/*:53*/
#line 966 "kNN_MDS.w"

else
if(sampled_eigen_flag)
{
cout<<"In finding eigen vectors, use only sampled data"<<endl;
/*52:*/
#line 2421 "kNN_MDS.w"

{
#ifdef DEBUG
cout<<"In calc, using sampled data, find |q| eigen values q ="<<q<<endl;
#endif




M*= 0.0;
for(int i= 0;i<n_sampling;i++)
M+= SX.Cols(i,i);
M*= 1.0/(Real)n_sampling;

#ifdef DEBUG
cout<<"mean M was calculated"<<endl;
#endif




Cov= SX*SX.t()*1.0/(Real)n_sampling-M*M.t();

#ifdef DEBUG
cout<<"covariance matrix Cov was calculated"<<endl;
#endif
total_variance= Cov.Tr();
cout<<"Total variance = "<<total_variance<<endl;

#ifdef DEBUG
cout<<"In> Cov.Eigen "<<endl;
#endif
ratio= Cov.Eigen(Eval,Evec,q);
n_sample_PCA= n_sampling;
}

/*:52*/
#line 971 "kNN_MDS.w"

}
else
/*51:*/
#line 2384 "kNN_MDS.w"

{
#ifdef DEBUG
cout<<"In calc, using all data, find |q| eigen values q ="<<q<<endl;
#endif




M*= 0.0;
for(int i= 0;i<n;i++)
M+= X.Cols(i,i);
M*= 1.0/(Real)n;

#ifdef DEBUG
cout<<"mean M was calculated"<<endl;
#endif




Cov= X*X.t()*1.0/(Real)n-M*M.t();

#ifdef DEBUG
cout<<"covariance matrix Cov was calculated"<<endl;
#endif
total_variance= Cov.Tr();
cout<<"Total variance = "<<total_variance<<endl;

#ifdef DEBUG
cout<<"In> Cov.Eigen "<<endl;
#endif
ratio= Cov.Eigen(Eval,Evec,q);
n_sample_PCA= n;
}

/*:51*/
#line 974 "kNN_MDS.w"



REAL cont_eff= 0.0;

for(int i= 0;i<q;i++)
{
PV(i)= Eval(i,i);
cont_eff+= PV(i)/total_variance;
}
cout<<"n_sample_PCA = "<<n_sample_PCA<<" cont_eff = "<<cont_eff<<endl;


if(q> 0)
{
/*55:*/
#line 2516 "kNN_MDS.w"

{


PX= Evec.t().Rows(0,q-1)*X;
PSX= Evec.t().Rows(0,q-1)*SX;

}

/*:55*/
#line 989 "kNN_MDS.w"

REAL*p_p_mean= new REAL[q];
REAL*p_p_var= new REAL[q];

/*30:*/
#line 1104 "kNN_MDS.w"

{
Matrix G(n_sampling*(n_sampling-1)/2,q);

int cc= 0;

for(int i= 0;i<n_sampling;i++)
{
for(int j= i+1;j<n_sampling;j++)
{
for(int s= 0;s<q;s++)
G(cc,s)= (PSX.Cols(i,i).Rows(0,s)-PSX.Cols(j,j).Rows(0,s)).Norm2();
cc++;
}
}

for(int k= 0;k<q;k++)
{
p_p_mean[k]= G.Cols(k,k).Mean();
p_p_var[k]= G.Cols(k,k).Variance(p_p_mean[k]);
}

if(n_sampling*(n_sampling-1)/2!=cc)
printf("*SSS* n_sampling*(n_sampling-1)/2=%d, cc=%d\n",n_sampling*(n_sampling-1)/2,cc);
}

/*:30*/
#line 993 "kNN_MDS.w"


for(int k= 0;k<q;k++)
{
cout<<"(X,Y): Mean ("<<k<<") = "<<p_p_mean[k]
<<"\tVariance ("<<k<<") = "<<p_p_var[k]<<endl;
}

REAL*p_nn_mean= new REAL[q];
REAL*p_nn_var= new REAL[q];
REAL*p_nn_tail= new REAL[q];


/*31:*/
#line 1131 "kNN_MDS.w"

{
Matrix F(n_sampling,q);

int j= 0;
REAL tmp;
REAL dd;
int cc= 0;

int nn= sampling_skip*n_sampling;
int ii;

for(int i= 0;i<n_sampling;i++)
{
for(int k= 0;k<q;k++)
{

F(i,k)= (PSX.Cols(i,i).Rows(0,k)-PX.Cols(NN[i],NN[i]).Rows(0,k)).Norm2();

if(i<n_tail)
{
P(i,k)= F(i,k);
}
else if(i==n_tail)
{
P(i,k)= F(i,k);

for(int i1= 0;i1<n_tail;i1++)
for(int i2= n_tail;i2> i1;i2--)
{
if(P(i2-1,k)<P(i2,k))
{
tmp= P(i2,k);
P(i2,k)= P(i2-1,k);
P(i2-1,k)= tmp;
}
}
}
else
{
if(F(i,k)> P(n_tail-1,k))
{
P(n_tail,k)= F(i,k);
for(int i2= n_tail;i2> 0;i2--)
{
if(P(i2-1,k)<P(i2,k))
{
tmp= P(i2,k);
P(i2,k)= P(i2-1,k);
P(i2-1,k)= tmp;
}
}
}
}
}




ii= i*sampling_skip;

dd= DIS2(ii,NN[i]);
if(i<n_tail)
{
P(i,q)= dd;
}
else if(i==n_tail)
{

P(i,q)= dd;
for(int i1= 0;i1<n_tail;i1++)
for(int i2= n_tail;i2> i1;i2--)
{
if(P(i2-1,q)<P(i2,q))
{
tmp= P(i2,q);
P(i2,q)= P(i2-1,q);
P(i2-1,q)= tmp;
}
}
}
else
{
if(dd> P(n_tail-1,q))
{
P(n_tail,q)= dd;
for(int i2= n_tail;i2> 0;i2--)
{
if(P(i2-1,q)<P(i2,q))
{
tmp= P(i2,q);
P(i2,q)= P(i2-1,q);
P(i2-1,q)= tmp;
}
}
}
}

cc++;
}

for(int k= 0;k<q;k++)
{
p_nn_mean[k]= F.Cols(k,k).Mean();
p_nn_var[k]= F.Cols(k,k).Variance(p_nn_mean[k]);
}

if(n_sampling!=cc)
printf("*SST* n_sampling=%d, cc=%d\n",n_sampling,cc);

}

/*:31*/
#line 1006 "kNN_MDS.w"


for(int k= 0;k<q;k++)
{
cout<<"(X,X_knn): Mean ("<<k<<") = "<<p_nn_mean[k]
<<"\tVariance ("<<k<<") = "<<p_nn_var[k]<<endl;
}

/*32:*/
#line 1244 "kNN_MDS.w"

{
Matrix G(n_sampling*(n_sampling-1)/2,q);

int cc= 0;
REAL dd;
int ii,jj;

int nn= sampling_skip*n_sampling;

for(int i= 0;i<n_sampling;i++)
{
for(int j= i+1;j<n_sampling;j++)
{
for(int k= 0;k<q;k++)
{
G(cc,k)= (PSX.Cols(i,i).Rows(0,k)-PSX.Cols(j,j).Rows(0,k)).Norm2();
for(int l= 0;l<n_tail;l++)
if(G(cc,k)> P(l,k))
XNtail(l,k)+= 1.0;
}


ii= i*sampling_skip;
jj= j*sampling_skip;

dd= DIS2(ii,jj);
for(int l= 0;l<n_tail;l++)
if(dd> P(l,q))
XNtail(l,q)+= 1.0;

cc++;
}
}


XNtail/= cc;

}

/*:32*/
#line 1014 "kNN_MDS.w"


}

}

/*:26*/
#line 689 "kNN_MDS.w"


/*67:*/
#line 2841 "kNN_MDS.w"

{
int pp;
for(int i= 1;i<n_error_level;i++)
{
pp= int(n_sampling*error_level[i]*0.01);
for(int k= 0;k<=q;k++)
{
threshold[i][k]= P(pp,k);
gain[i][k]= XNtail(pp,k);
printf("[Set up of threholds] threshold[%d][%d]=%e gain[%d][%d]=%e\n",
i,k,threshold[i][k],i,k,gain[i][k]);
}
}
}


/*:67*/
#line 691 "kNN_MDS.w"

}

/*70:*/
#line 3127 "kNN_MDS.w"

int nkind= 5;
enum kind{FullDistance,MarginalDistance,PartialDistance,RadiusTermination,RFullDistance};
const char*kindname[]= 
{"Full Distance","Marginal Distance","Partial Distance","Radius Termination",
"Recovery FullDist"};
long*kcounter= new long[nkind];

unsigned long*examined_dim= new unsigned long[m];

for(int i= 0;i<nkind;i++)
kcounter[i]= 0;

for(int i= 0;i<m;i++)
examined_dim[i]= 0;

int term_flag;
REAL r2;
int checked_sample= 0;
int edim;
REAL current_d2;
int isample;
REAL theta_q;
int kNN;

ncorrect= 0;
nwrong= 0;

/*:70*/
#line 694 "kNN_MDS.w"


if(q> 0||allpca_flag)
/*61:*/
#line 2651 "kNN_MDS.w"

if(allpca_flag)
{
ev= new REAL*[m];
for(int i= 0;i<m;i++)
{
ev[i]= new REAL[m];
for(int j= 0;j<m;j++)
ev[i][j]= Evec(j,i);
}
}
else if(q> 0)
{
ev= new REAL*[q];
for(int i= 0;i<q;i++)
{
ev[i]= new REAL[m];
for(int j= 0;j<m;j++)
ev[i][j]= Evec(j,i);
}
}

px= new REAL[m];

/*:61*/
#line 697 "kNN_MDS.w"


if(!model_in_flag)
/*63:*/
#line 2701 "kNN_MDS.w"

if(allpca_flag)
/*57:*/
#line 2540 "kNN_MDS.w"

{
PX= Evec.t()*X;
for(int i= 0;i<n;i++)
for(int j= 0;j<m;j++)
trx[i][j]= PX(j,i);
ptrx= trx;

}



/*:57*/
#line 2703 "kNN_MDS.w"

else if(q> 0)
/*56:*/
#line 2526 "kNN_MDS.w"

{

ptrx= new REAL*[n];
for(int i= 0;i<n;i++)
ptrx[i]= new REAL[q];

for(int i= 0;i<n;i++)
for(int j= 0;j<q;j++)
ptrx[i][j]= PX(j,i);

}

/*:56*/
#line 2705 "kNN_MDS.w"



/*:63*/
#line 700 "kNN_MDS.w"


if(!model_in_flag&&tflag)
{
/*58:*/
#line 2553 "kNN_MDS.w"

try{
TermR2= new REAL[n];
}
catch(bad_alloc)
{
cerr<<"*E* cannot allocate memory for TermR2 with size  "<<
n<<" for dimension "<<m<<endl;
exit(0);
}

/*:58*/
#line 704 "kNN_MDS.w"
;

if(n_sampling<n)
/*62:*/
#line 2676 "kNN_MDS.w"

{
REAL pdisq;
int cc= 0;
REAL vmin;
int nmin;

int*kno= new int[K];
REAL*kdis= new REAL[K];

cc= 0;
for(int i= 0;i<n;i++)
{
find_k_nn_in_training(K,i,n,trx,kno,kdis);
NN[i]= kno[K-1];
if(tflag&&K> 1)
NNhalf[i]= kno[K/2];
}

delete[]kno;
delete[]kdis;

}

/*:62*/
#line 707 "kNN_MDS.w"
;

/*59:*/
#line 2565 "kNN_MDS.w"



{
cout<<"IN > Termination Distance "<<endl;

if(nc> 1)
{
int pk2= int(kk/2);
int nk2= int((kk+1)/2);

int*knn_id= new int[nk2];
REAL*knn_dis= new REAL[nk2];

REAL pd2;
REAL nd2;
REAL dd;
int icls;

for(int i= 0;i<n;i++)
{

if(K> 1)
pd2= DIS2(i,NNhalf[i]);
else
pd2= 0.0;




icls= class_from_num(i,tr_pc,nc);

stock_k_nn(nk2,1.e33,0,knn_id,knn_dis,0,1);

for(int jcls= 0;jcls<icls;jcls++)
/*60:*/
#line 2632 "kNN_MDS.w"


{
int st= 0;
int ed;

for(int j= 0;j<jcls;j++)
st+= tr_pc[j];
ed= st+tr_pc[jcls];

for(int j= st;j<ed;j++)
{
dd= DIS2(i,j);
stock_k_nn(nk2,dd,j,knn_id,knn_dis);
}
}


/*:60*/
#line 2600 "kNN_MDS.w"
;


for(int jcls= icls+1;jcls<nc;jcls++)
/*60:*/
#line 2632 "kNN_MDS.w"


{
int st= 0;
int ed;

for(int j= 0;j<jcls;j++)
st+= tr_pc[j];
ed= st+tr_pc[jcls];

for(int j= st;j<ed;j++)
{
dd= DIS2(i,j);
stock_k_nn(nk2,dd,j,knn_id,knn_dis);
}
}


/*:60*/
#line 2604 "kNN_MDS.w"
;

nd2= stock_k_nn(nk2,0.0,0,knn_id,knn_dis,1);

TermR2[i]= 0.25*(sqrt(nd2)-sqrt(pd2))*(sqrt(nd2)-sqrt(pd2));

if(TermR2[i]<=0)
{
cerr<<"*Strange* nd2="<<nd2<<" pd2="<<pd2<<endl;
}

}

delete[]knn_id;
delete[]knn_dis;
}
else
{
for(int i= 0;i<n;i++)
TermR2[i]= 0.25*DIS2(i,NN[i]);
}

}

/*:59*/
#line 709 "kNN_MDS.w"
;

}


/*:15*/
#line 278 "kNN_MDS.w"
;

if(!model_in_flag)
/*78:*/
#line 3251 "kNN_MDS.w"

X.Release();
SX.Release();
M.Release();
Cov.Release();
Eval.Release();
PV.Release();
PX.Release();

/*:78*/
#line 281 "kNN_MDS.w"
;

if(!model_in_flag)
{
iri= new int[n];
for(int i= 0;i<n;i++)
iri[i]= i;
}

cout<<"--(1.3)-- Reading of a model file."<<endl;
if(model_in_flag)
/*24:*/
#line 848 "kNN_MDS.w"

{
FILE*fp;
fp= fopen(in_file,"r");

if(tflag)
try{
TermR2= new REAL[n];
}
catch(bad_alloc)
{
cerr<<"*E* cannot allocate memory for TermR2 with size  "<<
n<<" for dimension "<<m<<endl;
exit(0);
}

int iallpca_flag,ipflag,itflag,irflag;
int iq,im,in;

if(allpca_flag)
ptrx= trx;
else
{
ptrx= new REAL*[n];
for(int i= 0;i<n;i++)
ptrx[i]= new REAL[q];
}

/*69:*/
#line 2977 "kNN_MDS.w"

{
int dummy;
static char*s= new char[512];
char iver[256];
fscanf(fp,"# Version: %s\n",&iver);
if(strncmp(ver,iver,5)!=0)
{
fprintf(stdout,"(Error) Version does not mactch: expected version = %s for model version %s\n",
ver,iver);
exit(0);
}

fscanf(fp,"# Data parameter n, m\n");
fscanf(fp,"%d %d\n",&in,&im);
fscanf(fp,"# parameter q\n");
fscanf(fp,"%d\n",&iq);
fscanf(fp,"# flag parameters: allpca_flag, pflag, tflag, rflag\n");
fscanf(fp,"%1d %1d %1d %1d\n",&iallpca_flag,&ipflag,&itflag,&irflag);
fscanf(fp,"# thresholds, error_level, gain_level\n");

if(n!=in||m!=im)
{
fprintf(stdout,"(Error) Input file does not match : n=%d m=%d vs. in=%d im=%d\n",
n,m,in,im);
exit(0);
}

if(iq> q)
{
for(int i= 0;i<n_error_level;i++)
{
gain[i]= new REAL[iq+1];
threshold[i]= new REAL[iq+1];
gain[0][i]= 0.0;
}
for(int i= 0;i<n;i++)
{
ptrx[i]= new REAL[iq];
}
ev= new REAL*[iq];
for(int i= 0;i<iq;i++)
ev[i]= new REAL[m];

}

int pp;
REAL a,b;
for(int i= 0;i<n_error_level;i++)
{
if(sizeof(REAL)==sizeof(double))
fscanf(fp,"%lf ",&a);
else
fscanf(fp,"%f ",&a);

for(int j= 0;j<=iq;j++)
{
if(sizeof(REAL)==sizeof(double))
fscanf(fp,"%lf %lf ",&threshold[i][j],&gain[i][j]);
else
fscanf(fp,"%f %f ",&threshold[i][j],&gain[i][j]);
}
fscanf(fp,"\n");
}



if(allpca_flag)
{

fscanf(fp,"# Number of eigen vectors\n");
fscanf(fp,"%d\n",&m);
fscanf(fp,"# Eigen vectors\n");
for(int i= 0;i<m;i++)
{
for(int j= 0;j<m;j++)
if(sizeof(REAL)==sizeof(double))
fscanf(fp,"%lf ",&ev[i][j]);
else
fscanf(fp,"%f ",&ev[i][j]);
fscanf(fp,"\n");
}
fscanf(fp,"# Transformed data\n");
int i;
for(int ii= 0;ii<n;ii++)
{
i= iri[ii];

for(int j= 0;j<m;j++)
if(sizeof(REAL)==sizeof(double))
fscanf(fp,"%lf ",&ptrx[i][j]);
else
fscanf(fp,"%f ",&ptrx[i][j]);

fscanf(fp,"\n");
}
}
else
{

fscanf(fp,"# Number of eigen vectors\n");
fscanf(fp,"%d\n",&q);
fscanf(fp,"# Eigen vectors\n");

for(int i= 0;i<n;i++)
{
for(int j= 0;j<m;j++)
if(sizeof(REAL)==sizeof(double))
fscanf(fp,"%lf ",&ev[i][j]);
else
fscanf(fp,"%f ",&ev[i][j]);
fscanf(fp,"\n");
}
fscanf(fp,"# Transformed data\n");
int i;

for(int ii= 0;ii<n;ii++)
{
i= iri[ii];
for(int j= 0;j<iq;j++)
if(sizeof(REAL)==sizeof(double))
fscanf(fp,"%lf ",&ptrx[i][j]);
else
fscanf(fp,"%f ",&ptrx[i][j]);
fscanf(fp,"\n");
}
}
if(tflag)
{
fscanf(fp,"# Termination radius\n");
int i;
for(int ii= 0;ii<n;ii++)
{
i= iri[ii];
if(sizeof(REAL)==sizeof(double))
fscanf(fp,"%lf\n",&TermR2[i]);
else
fscanf(fp,"%f\n",&TermR2[i]);
}
}

if(sizeof(REAL)==sizeof(double))
fscanf(fp,"# Estimated execution costs: c1&c2= %lf %lf\n",&c1,&c2);
else
fscanf(fp,"# Estimated execution costs: c1&c2= %f %f\n",&c1,&c2);

printf("# Estimated execution costs: c1&c2= %f %f\n",c1,c2);
}

/*:69*/
#line 876 "kNN_MDS.w"

if(0)
{
fp= stdout;
/*66:*/
#line 2771 "kNN_MDS.w"

{
fprintf(fp,"# Version: %s\n",ver);
fprintf(fp,"# Data parameter n, m\n");
fprintf(fp,"%d %d\n",n,m);
fprintf(fp,"# parameter q\n");
fprintf(fp,"%d\n",q);
fprintf(fp,"# flag parameters: allpca_flag, pflag, tflag, rflag\n");
fprintf(fp,"%1d %1d %1d %1d\n",allpca_flag,pflag,tflag,rflag);
fprintf(fp,"# thresholds, error_level, gain_level\n");
int pp;
for(int i= 0;i<n_error_level;i++)
{
fprintf(fp,"%f ",error_level[i]);
for(int j= 0;j<=q;j++)
fprintf(fp,"%15.12f %15.12f ",threshold[i][j],gain[i][j]);
fprintf(fp,"\n");
}

if(allpca_flag)
{
fprintf(fp,"# Number of eigen vectors\n");
fprintf(fp,"%d\n",m);
fprintf(fp,"# Eigen vectors\n");
for(int i= 0;i<m;i++)
{
for(int j= 0;j<m;j++)
fprintf(fp,"%f ",ev[i][j]);
fprintf(fp,"\n");
}
fprintf(fp,"# Transformed data\n");
for(int i= 0;i<n;i++)
{
for(int j= 0;j<m;j++)
fprintf(fp,"%f ",ptrx[i][j]);
fprintf(fp,"\n");
}
}
else
{
fprintf(fp,"# Number of eigen vectors\n");
fprintf(fp,"%d\n",q);
fprintf(fp,"# Eigen vectors\n");
for(int i= 0;i<q;i++)
{
for(int j= 0;j<m;j++)
fprintf(fp,"%f ",ev[i][j]);
fprintf(fp,"\n");
}
fprintf(fp,"# Transformed data\n");
for(int i= 0;i<n;i++)
{
for(int j= 0;j<q;j++)
fprintf(fp,"%f ",ptrx[i][j]);
fprintf(fp,"\n");
}
}
if(tflag)
{
fprintf(fp,"# Termination radius\n");
for(int i= 0;i<n;i++)
fprintf(fp,"%f\n",TermR2[i]);
}

/*71:*/
#line 3157 "kNN_MDS.w"

{
time_t t1,t2,tt;
time_t st,ed;
int N_time= 1000;

cout<<"Now measuring actual time of distance calc and inner product ..\
it will take about 40 seconds"<<endl;


ColumnVector u(m);
ColumnVector v(m);
RandomMatrix U(m,1);
u<<U;
RandomMatrix V(m,1);
v<<V;


int R_time= 0;
t1= 0;
st= (unsigned)time(NULL);
while(t1<20)
{
for(int i= 0;i<N_time;i++)
DIS2(u,v);
ed= (unsigned)time(NULL);
t1= ed-st;
R_time++;
}


st= (unsigned)time(NULL);
for(int r= 0;r<R_time;r++)
for(int i= 0;i<N_time;i++)
innerp(u,v);
ed= (unsigned)time(NULL);
t2= ed-st;

c1= (REAL)t1;
c2= (REAL)t2;
printf("In estimation of time coefficients: c1=%f (t1=%d) for dist calc.\
 and c2=%f (t2=%d) for inner product with N_time %d x R_time %d\n",c1,t1,c2,t2,N_time,R_time);
printf("** Be careful, time %d was consumed in this estimation\n",t2+t2);
}

/*:71*/
#line 2835 "kNN_MDS.w"

fprintf(fp,"# Estimated execution costs: c1&c2= %f %f\n",c1,c2);

}

/*:66*/
#line 880 "kNN_MDS.w"

}

if(iallpca_flag<allpca_flag)
{
printf("(Error) You cannot specify %s option that does not match\
 the model file: flag =%d iflag=%d\n","allpca_flag",allpca_flag,iallpca_flag);
exit(0);
}

if(ipflag<pflag)
{
printf("(Error) You cannot specify %s option that does not match\
 the model file: flag =%d iflag=%d\n","pflag",pflag,ipflag);
exit(0);
}

if(itflag<tflag)
{
printf("(Error) You cannot specify %s option that does not match\
 the model file: flag =%d iflag=%d\n","tflag",tflag,itflag);
exit(0);
}

fclose(fp);
}

/*:24*/
#line 292 "kNN_MDS.w"
;

if(pair==NULL)
pair= new CELL[n];

if(model_out_flag)
{
/*25:*/
#line 908 "kNN_MDS.w"

{
FILE*fp;
fp= fopen(out_file,"w");
/*66:*/
#line 2771 "kNN_MDS.w"

{
fprintf(fp,"# Version: %s\n",ver);
fprintf(fp,"# Data parameter n, m\n");
fprintf(fp,"%d %d\n",n,m);
fprintf(fp,"# parameter q\n");
fprintf(fp,"%d\n",q);
fprintf(fp,"# flag parameters: allpca_flag, pflag, tflag, rflag\n");
fprintf(fp,"%1d %1d %1d %1d\n",allpca_flag,pflag,tflag,rflag);
fprintf(fp,"# thresholds, error_level, gain_level\n");
int pp;
for(int i= 0;i<n_error_level;i++)
{
fprintf(fp,"%f ",error_level[i]);
for(int j= 0;j<=q;j++)
fprintf(fp,"%15.12f %15.12f ",threshold[i][j],gain[i][j]);
fprintf(fp,"\n");
}

if(allpca_flag)
{
fprintf(fp,"# Number of eigen vectors\n");
fprintf(fp,"%d\n",m);
fprintf(fp,"# Eigen vectors\n");
for(int i= 0;i<m;i++)
{
for(int j= 0;j<m;j++)
fprintf(fp,"%f ",ev[i][j]);
fprintf(fp,"\n");
}
fprintf(fp,"# Transformed data\n");
for(int i= 0;i<n;i++)
{
for(int j= 0;j<m;j++)
fprintf(fp,"%f ",ptrx[i][j]);
fprintf(fp,"\n");
}
}
else
{
fprintf(fp,"# Number of eigen vectors\n");
fprintf(fp,"%d\n",q);
fprintf(fp,"# Eigen vectors\n");
for(int i= 0;i<q;i++)
{
for(int j= 0;j<m;j++)
fprintf(fp,"%f ",ev[i][j]);
fprintf(fp,"\n");
}
fprintf(fp,"# Transformed data\n");
for(int i= 0;i<n;i++)
{
for(int j= 0;j<q;j++)
fprintf(fp,"%f ",ptrx[i][j]);
fprintf(fp,"\n");
}
}
if(tflag)
{
fprintf(fp,"# Termination radius\n");
for(int i= 0;i<n;i++)
fprintf(fp,"%f\n",TermR2[i]);
}

/*71:*/
#line 3157 "kNN_MDS.w"

{
time_t t1,t2,tt;
time_t st,ed;
int N_time= 1000;

cout<<"Now measuring actual time of distance calc and inner product ..\
it will take about 40 seconds"<<endl;


ColumnVector u(m);
ColumnVector v(m);
RandomMatrix U(m,1);
u<<U;
RandomMatrix V(m,1);
v<<V;


int R_time= 0;
t1= 0;
st= (unsigned)time(NULL);
while(t1<20)
{
for(int i= 0;i<N_time;i++)
DIS2(u,v);
ed= (unsigned)time(NULL);
t1= ed-st;
R_time++;
}


st= (unsigned)time(NULL);
for(int r= 0;r<R_time;r++)
for(int i= 0;i<N_time;i++)
innerp(u,v);
ed= (unsigned)time(NULL);
t2= ed-st;

c1= (REAL)t1;
c2= (REAL)t2;
printf("In estimation of time coefficients: c1=%f (t1=%d) for dist calc.\
 and c2=%f (t2=%d) for inner product with N_time %d x R_time %d\n",c1,t1,c2,t2,N_time,R_time);
printf("** Be careful, time %d was consumed in this estimation\n",t2+t2);
}

/*:71*/
#line 2835 "kNN_MDS.w"

fprintf(fp,"# Estimated execution costs: c1&c2= %f %f\n",c1,c2);

}

/*:66*/
#line 912 "kNN_MDS.w"

printf("All distribution parameters were held in file %s\n",out_file);
fclose(fp);
}



/*:25*/
#line 299 "kNN_MDS.w"
;

/*84:*/
#line 3476 "kNN_MDS.w"

{
FILE*fp;
char ofile[256];
sprintf(ofile,"%s_sorted_index",out_file);
fp= fopen(ofile,"w");

/*79:*/
#line 3261 "kNN_MDS.w"

{


for(int i= 0;i<n;i++)
{
pair[i].id= i;
pair[i].val= ptrx[i][0];
}

qsort(pair,n,sizeof(CELL),comp_score);

for(int i= 0;i<n;i++)
pair[pair[i].id].rid= i;

#ifdef DEBUG
printf("Sorting result  ... of %d data in 1st principal axis\n",n);
for(int i= 0;i<n;i++)
{
printf("(i=%d, id=%d, rid=%d, %lf)\n",i,pair[i].id,pair[i].rid,pair[i].val);
if(i%10==9)
printf("\n");
}
#endif

}


/*:79*/
#line 3483 "kNN_MDS.w"


fprintf(fp,"n= %d m= %d\n",n,m);
for(int i= 0;i<n;i++)
fprintf(fp,"%d %d %f\n",pair[i].rid,pair[i].id,pair[i].val);

fclose(fp);
}

/*:84*/
#line 301 "kNN_MDS.w"
;
exit(0);
}






cout<<"--(2)-- Estimated percentile information "<<endl;

/*68:*/
#line 2859 "kNN_MDS.w"

{


cout<<" --- User Selection of Error Probability ---"<<endl;
cout<<"\t\t Expected Distance Reduction Rate\n";
cout<<"No.  Error(\%) \t";
for(int k= 0;k<q;k++)
cout<<"   q=  "<<k+1<<"\t";
cout<<"   q=  "<<m<<"\t";
cout<<endl;

int*opt_q= new int[n_error_level];

int pp;
for(int i= 1;i<n_error_level;i++)
{
pp= int(n_sampling*error_level[i]*0.01);
printf("%1d - %f :\t",i,error_level[i]);
for(int k= 0;k<=q;k++)
printf("%7.3f \t",gain[i][k]);
printf("\n");

int mk;
REAL rk= 1.e33;
REAL r;
for(int k= 0;k<q;k++)
{
r= estimated_reduction(n,m,k+1,gain[i][k]);
if(r<rk)
{
mk= k;
opt_q[i]= mk;
rk= r;
}
}

printf("Predic, R-rate\t");
for(int k= 0;k<=q;k++)
printf("%7.3f%c \t",estimated_reduction(n,m,k+1,gain[i][k]),
(k==mk)?'*':' ');



printf("\n");
}

int select_level;
if(A<0)
{
cout<<" - Choose one by the integer from 0: no threshold, 1-"<<n_error_level-1<<
" in above table"<<endl;
cin>>select_level;
while(select_level<0||select_level>=n_error_level)
{
cout<<" - *Warning* Rechoose one by the integer from 0: no threshold, 1-"<<
n_error_level-1<<" in above table"<<endl;
cin>>select_level;
}
}
else
select_level= A;

cout<<" ----- ( Selection of epsion and marginal dimension ) with user-specified A= "<<
A<<" ---- "<<endl;

if(narrow==Nothing||narrow==Filtering)
cout<<"1) Error rate = "<<error_level[select_level]<<" % "<<endl;
else
cout<<"1) Error rate +1 0.1%% error= "<<error_level[select_level]+0.1<<" % "<<endl;



if(qsdim==0)
q= opt_q[select_level]+1;
else
q= qsdim;

cout<<"2) Marginal dimension = "<<q<<endl;

pp= int(n_sampling*error_level[select_level]*0.01);

for(int i= 0;i<=q;i++)
{
if(select_level==0)
{
thresh_l[i]= 1.e33;
q= 0;
cout<<"** q is reset to 0 "<<endl;
}
else
thresh_l[i]= threshold[select_level][i];
}


if(A> 0)
thresh_1st= threshold[1][0];
else
thresh_1st= 1.e33;

cout<<"\t thresh_1st was set to "<<thresh_1st<<" by threshold[1][0]"<<endl;

double delta;

if(q> 0)
delta= gain[select_level][q-1];
else
delta= 0.0;

cout<<"3) Threshold = "<<threshold[select_level][q-1]<<" with "<<pp
<<" tail samples"<<endl;
cout<<"4) Estimated probability of full distance = "<<(1.0-delta)*100.0<<" %"<<endl;
cout<<"5) Estimated time reduction rate = "<<
estimated_reduction(n,m,q+1,delta)<<endl;
cout<<" --------------------------------------------- "<<endl;
}

/*:68*/
#line 312 "kNN_MDS.w"


cout<<"--(3)-- Sorting on the 1st principal axis "<<endl;

if(!model_in_flag)
/*79:*/
#line 3261 "kNN_MDS.w"

{


for(int i= 0;i<n;i++)
{
pair[i].id= i;
pair[i].val= ptrx[i][0];
}

qsort(pair,n,sizeof(CELL),comp_score);

for(int i= 0;i<n;i++)
pair[pair[i].id].rid= i;

#ifdef DEBUG
printf("Sorting result  ... of %d data in 1st principal axis\n",n);
for(int i= 0;i<n;i++)
{
printf("(i=%d, id=%d, rid=%d, %lf)\n",i,pair[i].id,pair[i].rid,pair[i].val);
if(i%10==9)
printf("\n");
}
#endif

}


/*:79*/
#line 317 "kNN_MDS.w"



int*start_data_no;

if(!model_in_flag)
/*81:*/
#line 3336 "kNN_MDS.w"

{

REAL**trxd= new REAL*[n];
for(int i= 0;i<n;i++)
trxd[i]= new REAL[m];

REAL**ptrxd;
ptrxd= new REAL*[n];

if(allpca_flag==0)
for(int i= 0;i<n;i++)
ptrxd[i]= new REAL[q];
else
for(int i= 0;i<n;i++)
ptrxd[i]= new REAL[m];

REAL*pp,*pq;
int target;

#ifdef DEBUG
for(int i= 0;i<100;i++)
{
printf("(%d, %lf, %lf) ",i,ptrx[i][0],trx[i][0]);
if(i%10==9)
printf("\n");
}
#endif

printf("--- Sort of given data in the order of 1st principal axis\n");

for(int i= 0;i<n;i++)
{
target= pair[i].id;

if(i%100==99)
printf("Data copy from %d -> %d\n",target,i);
pp= trxd[i];
pq= trx[target];
for(int j= 0;j<m;j++)
*pp++= *pq++;

pp= ptrxd[i];
pq= ptrx[target];

if(allpca_flag==0)
for(int j= 0;j<q;j++)
*pp++= *pq++;
else
for(int j= 0;j<m;j++)
*pp++= *pq++;

}

for(int i= 0;i<n;i++)
{
delete[]trx[i];
if(!allpca_flag)
delete[]ptrx[i];
}
delete[]trx;
if(!allpca_flag)
delete[]ptrx;

trx= trxd;
ptrx= ptrxd;

#ifdef DEBUG
printf("--- Sorted data (top 100)\n");
for(int i= 0;i<100;i++)
{
printf("(%d, %lf, %lf) ",i,ptrx[i][0],trx[i][0]);
if(i%10==9)
printf("\n");
}
#endif

}


/*:81*/
#line 323 "kNN_MDS.w"
;


int B= B_default;
REAL W;
REAL w;
REAL sample_min;
REAL sample_max;
REAL th1st;
int iw;

if(narrow==Table_Lookup)
/*82:*/
#line 3423 "kNN_MDS.w"

{
th1st= sqrt(thresh_1st);
sample_min= pair[0].val;
sample_max= pair[n-1].val;
W= sample_max-sample_min;
int BB= B_default*int(W/th1st);
if(BB> B)
B= BB;
w= W/REAL(B);

printf("Establish of data structure: n=%d W=%f B=%d w=%f th=%f in [%f - %f]\n",
n,W,B,w,th1st,sample_min,sample_max);

iw= int(th1st/w)+1;

REAL stv= pair[0].val+w;
start_data_no= new int[B+2];

start_data_no[0]= 0;
int next= 1;
for(int i= 1;i<n;i++)
while(pair[i].val> stv)
{
start_data_no[next]= i;
next++;
stv+= w;
}
start_data_no[next]= n-1;

}

/*:82*/
#line 335 "kNN_MDS.w"










/*36:*/
#line 1671 "kNN_MDS.w"

{

cout<<"In read testing data ! "<<endl;

char line[Max_Line];
char word[Max_Line][50];
FILE*fp_tr;

int D= 0;

int nread;
file_in= file_te;

if(!std_in_flag)
{
/*34:*/
#line 1581 "kNN_MDS.w"

{
FILE*fp_in;
if((fp_in= fopen(file_in,"r"))==NULL)
{
fprintf(stderr," * file <%s> open error * \n",file_in);
exit(0);
}
int nw;

nread= 0;

while((nw= getword_of_line(fp_in,line,word,Max_Line))!=0)
{
if(n==0)
m= nw;
nread++;
}
fclose(fp_in);


}

/*:34*/
#line 1687 "kNN_MDS.w"
;
n_te= nread;
cout<<"n_te = "<<n_te<<" m = "<<m<<endl;

if((fp_tr= fopen(file_te,"r"))==NULL)
{
printf(" * testing file < %s > open error * \n",file_te);
exit(0);
}

te_data= new REAL*[n_te];
{
for(int i= 0;i<n_te;i++)
te_data[i]= new REAL[m];
}

}
else
{
fp_tr= stdin;
n_te= 1;
}
for(int i= 0;i<n_te;i++)
{
int nw= 0;
if((nw= getword_of_line(fp_tr,line,word,Max_Line))!=0)
{
if(nw!=m)
{
cerr<<"In reading test sample "<<i<<" size "<<nw<<" m= "<<m<<endl;
exit(0);
}

for(int k= 0;k<nw;k++)
te_data[i][k]= REAL(atof(word[k]));
}

}
fclose(fp_tr);

}


/*:36*/
#line 345 "kNN_MDS.w"
;

if(!te_flag)
/*17:*/
#line 727 "kNN_MDS.w"

{
printf("\n * Wmmm ... < Testing Sample >set equivalent samples for each\
 class by %d \n",
n_te/nc);
fflush(stdout);
for(int i= 0;i<nc;i++)
te_pc[i]= n_te/nc;
}


/*:17*/
#line 348 "kNN_MDS.w"
;

if(n_te==0)
{
fprintf(stdout,"n_te = 0\n");
exit(0);
}

/*14:*/
#line 660 "kNN_MDS.w"


REAL*x;
int*knn_id= new int[K];
REAL*knn_dis= new REAL[K];

int cc= 0;
int cl;
int guess_cl;



/*:14*/
#line 356 "kNN_MDS.w"
;

time_t stime,etime;

printf("Start-time %u\n",stime= (unsigned)time(NULL));


cout<<"--(4)-- kNN's (OUT class distance id) "<<endl;
for(int i= 0;i<n_te;i++)
{
isample= i;

cl= class_from_num(i,te_pc,nc);

/*42:*/
#line 2186 "kNN_MDS.w"

x= te_data[i];


/*:42*/
#line 370 "kNN_MDS.w"
;

/*12:*/
#line 400 "kNN_MDS.w"

{














/*43:*/
#line 2191 "kNN_MDS.w"

if(allpca_flag)
{
for(int j= 0;j<m;j++)
px[j]= innerp(x,ev[j]);
if(q> 0)
theta_q= thresh_l[q-1];
}
else if(q> 0)
{
for(int j= 0;j<q;j++)
px[j]= innerp(x,ev[j]);
theta_q= thresh_l[q-1];
}

checked_sample= 0;
current_d2= stock_k_nn(K,0.0,0,knn_id,knn_dis,0,1);


/*:43*/
#line 416 "kNN_MDS.w"



static int int_st,int_ed;
static REAL th1st,q1st,qst,qed;
static REAL pp;

if(narrow==Binary_Search)
/*80:*/
#line 3290 "kNN_MDS.w"

{
REAL th1st= sqrt(thresh_1st);
REAL q1st= px[0];
REAL qst= q1st-th1st;
REAL qed= q1st+th1st;

int_st= 0;int_ed= n-1;


int pl= 0;
int pr= n-1;
int p= (pl+pr)/2;
REAL v;

while(pr> (pl+1))
{
v= pair[p].val;
if(v<qst)
pl= p;
if(v>=qst)
pr= p;
p= (pl+pr)/2;
}
int_st= (pl> 0)?pl-1:0;


pl= int_st;
pr= n-1;
p= (pl+pr)/2;

while(pr> (pl+1))
{
v= pair[p].val;
if(v<qed)
pl= p;
if(v>=qed)
pr= p;
p= (pl+pr)/2;
}
int_ed= (pr<n)?pr:n-1;

}


/*:80*/
#line 424 "kNN_MDS.w"

else if(narrow==Table_Lookup)
/*83:*/
#line 3456 "kNN_MDS.w"

{
REAL q1st= px[0];

int ind= int((q1st-sample_min)/w);
int_st= ((ind-iw)>=0)?ind-iw:0;
int_ed= ((ind+iw+1)<B)?ind+iw+1:B;

int_st= start_data_no[int_st];
int_ed= start_data_no[int_ed];

#ifdef DEBUN
printf("Found subset starts for q=%f (ind=%d B=%d, w=%f, iw=%d) at %d and ends at %d in \
(%f - %f) for th=%f\n",
q1st,ind,B,w,iw,int_st,int_ed,pair[int_st].val,pair[int_ed].val,th1st);
#endif

}

/*:83*/
#line 426 "kNN_MDS.w"

else
{
int_st= 0;int_ed= n-1;
th1st= sqrt(thresh_1st);
q1st= px[0];
qst= q1st-th1st;
qed= q1st+th1st;
}

#ifdef DEBUG
cout<<"Interval on 1st dim : for q_0= "<<px[0]<<" and th= "<<thresh_1st<<
" sorted_id "<<int_st<<" : "<<int_ed<<
" value "<<pair[int_st].val<<" : "<<pair[int_ed].val<<endl;
#endif

/*74:*/
#line 3222 "kNN_MDS.w"

#ifdef COUNTER
kcounter[MarginalDistance]+= (n-(int_ed-int_st+1));
examined_dim[0]+= (n-(int_ed-int_st+1));
#endif

/*:74*/
#line 442 "kNN_MDS.w"
;

int i;

for(int i= int_st;i<=int_ed;i++)
{

term_flag= 0;
r2= 0.0;

if(q> 0)

{

REAL d;
for(int j= 0;j<q;j++)
{
d= px[j]-ptrx[i][j];
r2+= d*d;
}

if(r2> theta_q)
{
term_flag= 1;
edim= q-1;
/*73:*/
#line 3215 "kNN_MDS.w"

#ifdef COUNTER
kcounter[MarginalDistance]++;
examined_dim[edim]++;
#endif

/*:73*/
#line 467 "kNN_MDS.w"
;
continue;
}
}

if(pflag)

{
REAL d;
if(allpca_flag==0)
{
r2= 0.0;
for(int j= 0;j<m;j++)
{
d= x[j]-trx[i][j];
r2+= d*d;

if(r2> current_d2/((1.0+eta)*(1.0+eta)))
{
term_flag= 1;
edim= j;
break;
}
}
}
else
{
for(int j= q;j<m;j++)
{
d= px[j]-ptrx[i][j];
r2+= d*d;
if(r2> current_d2/((1.0+eta)*(1.0+eta)))
{
term_flag= 1;
edim= j;
break;
}

}
}
if(term_flag==1)
{
/*75:*/
#line 3229 "kNN_MDS.w"

#ifdef COUNTER
kcounter[PartialDistance]++;
examined_dim[edim]++;
#endif

/*:75*/
#line 509 "kNN_MDS.w"
;
continue;
}
else
{
/*76:*/
#line 3236 "kNN_MDS.w"

#ifdef COUNTER
kcounter[FullDistance]++;
examined_dim[m-1]++;
#endif

/*:76*/
#line 514 "kNN_MDS.w"
;
}
}
else

{
r2= DIS2(x,trx[i]);

/*76:*/
#line 3236 "kNN_MDS.w"

#ifdef COUNTER
kcounter[FullDistance]++;
examined_dim[m-1]++;
#endif

/*:76*/
#line 522 "kNN_MDS.w"
;
}

checked_sample++;


if(r2<current_d2)
{
if(tflag)

/*45:*/
#line 2231 "kNN_MDS.w"

{
#ifdef DEBUG
cerr<<"In > Termination check with i "<<i<<endl;
#endif
if(r2<TermR2[i])
{
kcounter[RadiusTermination]+= (n-i);
term_flag= 2;
}
}

/*:45*/
#line 532 "kNN_MDS.w"
;

/*44:*/
#line 2211 "kNN_MDS.w"

{
#ifdef DEBUG
cerr<<"In > Update of kNN with current_d2= "<<current_d2<<" in sample "<<i
<<" rid="<<pair[i].id<<endl;
#endif
current_d2= stock_k_nn(K,r2,i,knn_id,knn_dis);
}

/*:44*/
#line 534 "kNN_MDS.w"
;

if(q> 0&&current_d2<theta_q)
theta_q= current_d2;

if(term_flag==2)
break;

}
}

r2= stock_k_nn(K,0.0,0,knn_id,knn_dis,1);

if(checked_sample==0)

{
printf("*RECOVER* with no examined sample for %d\n",isample);
/*77:*/
#line 3243 "kNN_MDS.w"

{
/*48:*/
#line 2259 "kNN_MDS.w"

#ifdef DEBUG
cerr<<"In > Full distance for every data"<<endl;
#endif
for(int i= 0;i<n;i++)
{
/*46:*/
#line 2244 "kNN_MDS.w"

#ifdef DEBUG
cerr<<"In > Full distance with allpca_flag "<<allpca_flag<<endl;
#endif

if(allpca_flag)
r2= DIS2(px,ptrx[i]);
else
r2= DIS2(x,trx[i]);

/*:46*/
#line 2265 "kNN_MDS.w"

if(r2<current_d2)
{
if(tflag)
/*45:*/
#line 2231 "kNN_MDS.w"

{
#ifdef DEBUG
cerr<<"In > Termination check with i "<<i<<endl;
#endif
if(r2<TermR2[i])
{
kcounter[RadiusTermination]+= (n-i);
term_flag= 2;
}
}

/*:45*/
#line 2269 "kNN_MDS.w"


/*44:*/
#line 2211 "kNN_MDS.w"

{
#ifdef DEBUG
cerr<<"In > Update of kNN with current_d2= "<<current_d2<<" in sample "<<i
<<" rid="<<pair[i].id<<endl;
#endif
current_d2= stock_k_nn(K,r2,i,knn_id,knn_dis);
}

/*:44*/
#line 2271 "kNN_MDS.w"

if(term_flag==2)
break;

}
}
kcounter[RFullDistance]++;


/*:48*/
#line 3245 "kNN_MDS.w"

r2= stock_k_nn(K,0.0,0,knn_id,knn_dis,1);
/*76:*/
#line 3236 "kNN_MDS.w"

#ifdef COUNTER
kcounter[FullDistance]++;
examined_dim[m-1]++;
#endif

/*:76*/
#line 3247 "kNN_MDS.w"
;
}

/*:77*/
#line 551 "kNN_MDS.w"

}
else if(rflag&&q> 0&&/*47:*/
#line 2255 "kNN_MDS.w"

((r2> thresh_l[q])?1:0)

/*:47*/
#line 553 "kNN_MDS.w"
)
{
printf("* Erly large: current_d2 =%f > thresh_l[%d]=%f\n",
r2,q,thresh_l[q]);
/*77:*/
#line 3243 "kNN_MDS.w"

{
/*48:*/
#line 2259 "kNN_MDS.w"

#ifdef DEBUG
cerr<<"In > Full distance for every data"<<endl;
#endif
for(int i= 0;i<n;i++)
{
/*46:*/
#line 2244 "kNN_MDS.w"

#ifdef DEBUG
cerr<<"In > Full distance with allpca_flag "<<allpca_flag<<endl;
#endif

if(allpca_flag)
r2= DIS2(px,ptrx[i]);
else
r2= DIS2(x,trx[i]);

/*:46*/
#line 2265 "kNN_MDS.w"

if(r2<current_d2)
{
if(tflag)
/*45:*/
#line 2231 "kNN_MDS.w"

{
#ifdef DEBUG
cerr<<"In > Termination check with i "<<i<<endl;
#endif
if(r2<TermR2[i])
{
kcounter[RadiusTermination]+= (n-i);
term_flag= 2;
}
}

/*:45*/
#line 2269 "kNN_MDS.w"


/*44:*/
#line 2211 "kNN_MDS.w"

{
#ifdef DEBUG
cerr<<"In > Update of kNN with current_d2= "<<current_d2<<" in sample "<<i
<<" rid="<<pair[i].id<<endl;
#endif
current_d2= stock_k_nn(K,r2,i,knn_id,knn_dis);
}

/*:44*/
#line 2271 "kNN_MDS.w"

if(term_flag==2)
break;

}
}
kcounter[RFullDistance]++;


/*:48*/
#line 3245 "kNN_MDS.w"

r2= stock_k_nn(K,0.0,0,knn_id,knn_dis,1);
/*76:*/
#line 3236 "kNN_MDS.w"

#ifdef COUNTER
kcounter[FullDistance]++;
examined_dim[m-1]++;
#endif

/*:76*/
#line 3247 "kNN_MDS.w"
;
}

/*:77*/
#line 557 "kNN_MDS.w"

}

kNN= knn_id[K-1];
kNN= pair[kNN].id;

if(kNN>=0)
{
if(K==1)
guess_cl= class_from_num(kNN,tr_pc,nc);
else if(K> 1)
{
int*vote= new int[nc];
for(int i= 0;i<nc;i++)
vote[i]= 0;

int iNN,gcl;
for(int i= 0;i<K;i++)
{
iNN= knn_id[i];
iNN= pair[iNN].id;
gcl= class_from_num(iNN,tr_pc,nc);
vote[gcl]++;
}
int maxgcl= 0;
int vv= vote[0];
for(int i= 1;i<nc;i++)
{
if(vote[i]> vv)
{
maxgcl= i;
vv= vote[i];
}
}
#ifdef DEBUG
printf("By the majority vote, guess_cl= %d with vote %d of %d\n",
maxgcl,vote[maxgcl],K);
#endif
guess_cl= maxgcl;
delete[]vote;
}

if(LP==2)
if(K==1)
printf("OUT  %d %f %d\n",guess_cl,sqrt(r2),kNN);
else if(K> 0)
{
printf("OUT  %d ",guess_cl);
int iNN,gcl;
REAL iDD;
for(int i= 0;i<K;i++)
{
iNN= knn_id[i];
iNN= pair[iNN].id;
iDD= knn_dis[i];
gcl= class_from_num(iNN,tr_pc,nc);
printf(", %d %f %d",gcl,sqrt(iDD),iNN);
}
printf("\n");
}
else
printf("OUT  %d %f %d\n",guess_cl,r2,kNN);
}
else
{
printf("*Error* for test sample %d : checked_sample =%d cand_d2 = %f\n",
isample,checked_sample,current_d2);
for(int i= 0;i<K;i++)
printf("knn_id[%d]=%d knn_dis[%d]=%f\n",i,knn_id[i],i,knn_dis[i]);
exit(0);
}


}

/*:12*/
#line 372 "kNN_MDS.w"


if(cl==guess_cl)
ncorrect++;
else
nwrong++;

}

cout<<"Complete !"<<endl;
if(nc> 1)
cout<<"Recognition Rate "<<REAL(ncorrect)/REAL(n_te)<<endl;

cout<<"--(5)-- k-NN's "<<endl;
/*13:*/
#line 637 "kNN_MDS.w"

{
#ifdef COUNTER

for(int i= 0;i<nkind;i++)
printf("Kind %s : counter = %8ld (%f \%) for %d tr samples  and %d te samples\n",
kindname[i],kcounter[i],100.0*REAL(kcounter[i])/REAL(n)/REAL(n_te),
n,n_te);

REAL fulldisnum= 0.0;
for(int i= 0;i<m;i++)
{
printf("Examined Dim %d : %u (%f \%)\n",
i,examined_dim[i],100.0*REAL(examined_dim[i])/REAL(n)/REAL(n_te));
fulldisnum+= examined_dim[i]*REAL(i+1)/REAL(m);
}
printf("Corresponding number of full distance calculations = %f\n",fulldisnum);

#endif

}

/*:13*/
#line 386 "kNN_MDS.w"
;

printf("End-time %u\n",etime= (unsigned)time(NULL));
printf("... Used-time %u\n",etime-stime);

}

/*:11*/
#line 237 "kNN_MDS.w"


/*:10*/
