//       list.h
//
//       class List <Abstract Class>... for operating lists
//

#ifndef _List
#define _List

#include <stdio.h>

#include "set.h"

//enum EnumType {binary, real, unknown};                     // Data Type
//enum EnumList {start=(-1), end=99999}; 


class List        // Abstract Class
{
public:  
  List* Next() {return _next;};
  List* Prev() {return _prev;};
  int No() { return _no;};
  int Num() ;                   // return the number of cells in the list
  virtual int Print(char *, int, FILE *)=0;
protected:
  List* _next;
  List* _prev;
  int _no;       // the number of the cell
};

class BList:public List        // Binary Data
{
public:
  BList(int bnum=0, int = 0);
  BList::BList(const BList& p)
    {
      _data = p._data;
      _inum = p._inum;
    }
  
//  Blist(const BList&);
  ~BList();
  BList& operator=(const BList&);
  int Add(BSet, BList* = NULL);
  int Delete(int=end);  // delete the i-th elements
  int Print(char * = "List", int = 0, FILE * = stdout);
  BSet Get(int = 0);
private:
  int _bnum;           // the number of effective bits
  int _inum;           // the number of integers
  BSet* _data;          // body of data
};

extern int BListRead(BList &, FILE *, int, int);  // read data from a file and make a BList


#endif /* _List */








