//    * This is a little risky but fast, because no range check
//    * Operator should apply to the same domain (no check)
//
//       set.C
//
//       class Set <Abstract Class>... for oprating several sets
//
//      Ver 1.1 (13 Aug. 2004)
//
#include <iostream>
#include <memory>
#include <cstdlib>
#include "set.h"

using namespace std;

int DefaultBSetSize;


inline void ByteBit(int x, int& B, int& b)
{
	B = x / ByteBound;   // needed number of integers
	b = x % ByteBound;   // bits
}

BSet::BSet(int rsize, int rbias)
{
  Init(rsize, rbias);
}

int BSet::Init(int rsize=0, int rbias=0)
{

	if (rsize == 0)
		return 0;

	/*
  if (rsize <= 0)
		rsize = DefaultBSetSize;
	*/

  _size = rsize;
  _min = rbias;
  _max = _min + rsize -1 ;
  _card = 0;
  _modflag = 0;  // The flag for calculation of the cardinality
  _inum = (rsize - 1) / (ByteBound) + 1;   // needed number of integers

  try {
		_elements = new WORD [_inum];
		//  cout << "(Alloc) _elements = " << _elements << endl;
  }
  catch (bad_alloc &e) {
		cerr << "*E* Cannot allocate memory for BSet with size " << _inum*sizeof(WORD) <<
			cerr << e.what() << endl;
  }

  for (int i=0; i<_inum; i++)  // Initialize of elements
    _elements[i] = 0;

  return 0;
}

BSet::BSet(const BSet& p)
{
  extern int dflag;

  Init(p._size, p._min);
  _card = p._card;
  _modflag = p._modflag; 

	memcpy(_elements, p._elements, _inum*sizeof(WORD));

}

BSet& BSet::operator=(const BSet& p)
{
	extern int dflag;

  if (this != &p)
    {

			delete [] _elements;  

      Init(p._size, p._min);
      _card = p._card;
      _modflag = p._modflag; 

			memcpy(_elements, p._elements, _inum*sizeof(WORD));

    }

  return *this;
}

BSet& BSet::RangeCopy(BSet& p, int st, int ed)
{
  if (this != &p)
    {
      delete [] _elements;  

      if (ed >= 0)  // Range specified copy
				{
					int size = ed - st;
	  
					Init(size, st);

					// copy of elements;
					_card = 0;
					for (int i=st; i<ed; i++)
						if (p.Mem(i))
							{
								Add(i);
								_card++;
							}
      
				}
      else  // Regular copy
				{
					Init(p._size, p._min);
					_card = p._card;
      
					memcpy(_elements, p._elements, _inum*sizeof(WORD));

				}
    }

  _modflag = 1;

  return *this;
}

BSet::~BSet()
{
	try {
		delete [] _elements;
	}
 	catch (...) {
		cout << "*Exception occurs" << endl;
	}
}

int BSet::Mem(int x)
{
	int inum, bitnum;
	x -= _min; 

	inum = x / ByteBound;   // needed number of integers
	bitnum = x % ByteBound;   // bits
     
	//	ByteBit(x, inum, bitnum);

	WORD tmp = _elements[inum];
	if (tmp == 0)
		return 0;
	else if (tmp == ~0)
		return 1;
	else
		{
			tmp >>= (ByteBound -1) - bitnum;
			return ( tmp & 0x1 );
		}

}


int BSet::Add(int x)
{

	    int inum, bitnum;
      x -= _min;      
	inum = x / ByteBound;   // needed number of integers
	bitnum = x % ByteBound;   // bits
     
	//	ByteBit(x, inum, bitnum);

      WORD tmp = 0x1;
      tmp <<= (ByteBound -1) - bitnum;
      WORD old = _elements[inum];
      _elements[inum] |= tmp;

      if ( old != _elements[inum] )
					_card++;

      return 0;

}

int BSet::Read(FILE* fp, int nbyte) // set bits by as a block 
{
  if (nbyte == 0) nbyte = _inum*WordSize;

  if ( nbyte > _inum*WordSize)
    {
      fprintf(stderr,"*Warning*(BSet::Read) %d bytes is over %d WORDS !\n",
							nbyte, _inum);
    }
  else
    {
      int stock = fread((char*)_elements, nbyte, 1, fp);
      if (stock != 1)
				{
					fprintf(stderr,"*Warning*(BSet::Read) Cannot read %d bytes from a file : srock = %d!\n",
									nbyte, stock);
					exit(0);
					return 0;
				}
    }  

  _min = 0;
  _size = nbyte * 8;
  _max = _size;

  Card(1);  // force recalculate

  return 1;
}


int BSet::Write(FILE* fp, int nbyte) // set bits by as a block 
{
  if ( nbyte > _inum*WordSize )
    {
      fprintf(stderr,"*Warning*(BSet::Write) %d bytes is cut by %d WORDS !\n",
							nbyte, _inum);
      nbyte = _inum*WordSize;
    }

  int c=0;
  if (nbyte == 0)
    {
      for (int i=0 ;i<_inum; i++)
				fwrite((char *)&_elements[i], WordSize, 1, fp);
    }
  else
    {
      fwrite((char*)_elements, nbyte, 1, fp);
    }


  return 1;
}

int BSet::Delete(int x)
{

      int inum, bitnum;
      x -= _min;      

	inum = x / ByteBound;   // needed number of integers
	bitnum = x % ByteBound;   // bits
	//      ByteBit(x, inum, bitnum);

      WORD tmp = 0x1;
      tmp <<= (ByteBound -1) - bitnum;
      tmp = ~tmp;

			WORD old = _elements[inum];
      _elements[inum] &= tmp;

			if (old != _elements[inum])
				_card--;

			return 0;

}

/*
BSet BSet::Complement()
{
  //  fprintf(stderr,"In Complement size=%d min=%d\n",_size,_min);

	BSet ans(_size, _min); 
  
	for (int i=_min; i<_min+_size; i++)
		if (! Mem(i))
			ans.Add(i);

	return ans;
}
*/

BSet BSet::Complement()
{

	BSet ans(_size, _min); 
  
	for (int i=0; i<_inum; i++)
		ans._elements[i] = ~_elements[i];

	ans._modflag = 1;
	return ans;
}


const int fold = 100;

void BSet::Print(char *s, int mode, FILE *fp)
	//  mode = 0 ... display as elements
	//         1 ... display as bits
	//         2 ... display as elements, but no braces
{

  fprintf(fp,"\n %s [min=%d, max=%d] cardinarity = %d\n",s,
					_min,_max,_card); 

  if (mode == 0)
    fprintf(fp,"{");

  int c=0;
  for (int i=0 ;i<_inum; i++)
    { 
      WORD tmp = _elements[i];
      for (int j=ByteBound-1; j>=0; j--)
				{
					if (mode == 1)
						{
							if ( c%fold == 0 ) fprintf(fp,"\n");
							fprintf(fp,"%1c",((tmp >> j) & 0x1) ? '1':'0'); 
							c++;
						}
					if ( (mode%2) == 0)
						{
							if (c+_min > _max)
								break;
							if ((tmp >> j) & 0x1) 
								fprintf(fp," %d",c+_min);
							c++;
						}

				}
    }

  if (mode == 0)
    fprintf(fp," }\n");
  else
    fprintf(fp,"\n");

}


int BSet::SameDomain(BSet& p, BSet& q)
{
	return ( (p._inum == q._inum && p._min == q._min) ? 1 : 0 );
}

BSet BSet::operator+(BSet& p)
{

      BSet ans(_size, _min); 

      for (int i=0; i<_inum; i++)
				ans._elements[i] = _elements[i]  | p._elements[i];

      ans._modflag = 1;
      return ans;
}



BSet BSet::operator*(BSet& p)
{

      BSet ans(_size, _min); 

      for (int i=0; i<_inum; i++)
    	  ans._elements[i] = _elements[i] & p._elements[i];

      ans._modflag = 1;

      return ans;
}


BSet BSet::operator-(BSet& p)
{

      BSet ans(_size, _min); 
     
      WORD tmp;
      for (int i=0; i<_inum; i++)
				{
					tmp = _elements[i] & p._elements[i];
					ans._elements[i] = _elements[i] ^ tmp;
				}
      ans._modflag = 1;

      return ans;

}

BSet BSet::operator^(BSet& p)
{
      BSet ans(_size, _min); 
      
      for (int i=0; i<_inum; i++)
      	ans._elements[i] = _elements[i] ^ p._elements[i];

      ans._modflag = 1;

      return ans;
}

BSet& BSet::operator+=(BSet& p)
{
      for (int i=0; i<_inum; i++)
				_elements[i] |= p._elements[i];

      _modflag = 1;

      return *this;
}

BSet& BSet::operator*=(BSet& p)
{
			for (int i=0; i<_inum; i++)
				_elements[i] &= p._elements[i];

			_modflag = 1;

			return *this;

}

BSet& BSet::operator-=(BSet& p)
{

			WORD tmp;
			for (int i=0; i<_inum; i++)
				{
					tmp = _elements[i] & p._elements[i];
					_elements[i] ^= tmp;
				}
			_modflag = 1;

      return *this;

}
BSet& BSet::operator^=(BSet& p)
{
      for (int i=0; i<_inum; i++)
      	_elements[i] ^= p._elements[i];

      _modflag = 1;
      return *this;

}


int BSet::operator<=(BSet& p)
{
  int m = _min;
  int M = _max;
  
  if ( _card > p._card )
    return 0;

	for (int i = 0; i < _inum; i++)
		if ( _elements[i] != ( _elements[i] & p._elements[i] ) )
			return 0;

  return 1;
}


int BSet::operator<(BSet& p)
{
  int m = _min;
  int M = _max;

  if ( *this <= p && Card() < p.Card())
    return 1;
  else
    return 0;
}

BSet& BSet::operator~()
{

	for (int i=0; i<_inum; i++)
		_elements[i] = ~_elements[i];

	_modflag = 1;
	return *this;
}

int BSet::operator>=(BSet& p)
{
  return (p <= *this);
}

int BSet::operator>(BSet& p)
{
  return (p < *this);
}

int BSet::operator==(BSet & p)
{
  int m = _min;
  int M = _max;
  
  if ( _card > p._card || _card < p._card)
    return 0;

			for (int i = 0; i < _inum; i++)
	      if ( _elements[i] != p._elements[i])
					return 0;

  return 1;

}

int BSet::Card(int setflag)
	//Does not use setflag
{

	if (_modflag == 0 && setflag == 0 )
		return _card;

	int n = 0;

	for(int i=0; i<_inum-1; i++)
		{
	    WORD x = _elements[i];
      if (x == 0)
				continue;
	    for (; x != 0; x >>= 1)
				if (x & 0x1)
						n++;
		}

  {
	WORD x = _elements[_inum-1];
	int inum, bitnum;

	inum = _max / ByteBound;   // needed number of integers
	bitnum = _max % ByteBound;   // bits

	//  ByteBit(_max, inum, bitnum);
	int shift = ByteBound -1 - bitnum;

  x >>= shift;

	if (x != 0)
		for (; x != 0; x >>= 1)
			if (x & 0x1)
					n++;

	}

  _card = n;

  _modflag =  0;

	return n;
}


int BSet::Empty(int limit)
	// Does not use limit
{

	if (_modflag == 0 )
		return ( (_card > limit) ? 0: 1 );

	int n = 0;
	for(int i=0; i<_inum -1 ; i++)
		{
	    WORD x = _elements[i];
      if (x == 0)
				continue;
			else
				return 0;

		}

	// Check last block
	WORD x = _elements[_inum-1];
	int inum, bitnum;
	inum = _max / ByteBound;   // needed number of integers
	bitnum = _max % ByteBound;   // bits

	//  ByteBit(_max, inum, bitnum);
	int shift = ByteBound -1 - bitnum;

  x >>= shift;

	if (x == 0)
		return 1;
	else 
		return 0;
}

int BSet::Full()
{

	if (_modflag == 0 )
		return ( (_card >= (_size)) ? 1: 0 );

	extern int dflag;

	int n = 0;
	for(int i=0; i<_inum-1; i++)
		{
	    WORD x = _elements[i];
      if (x == ~0)
				continue;
			else
				return 0;
		}

	// Check last block
	WORD x = _elements[_inum-1];
	int inum, bitnum;
	inum = _max / ByteBound;   // needed number of integers
	bitnum = _max % ByteBound;   // bits

	//  ByteBit(_max, inum, bitnum);
	int shift = ByteBound -1 - bitnum;

	x >>= shift;

  WORD y = ~0;

	y >>= shift;

	if (x == y)
		return 1;
	else 
		return 0;
}

BSet& BSet::operator!=(const BSet& p)  // Do not change the size of the
																			 // left BSet
{

  if (this != &p)
    {
      delete [] _elements;  

      int m = this->_min;
      Init(this->_size, 0);

      // copy of elements;
      BSet q = p;
      _card = 0;
      for (int i=m; i<(m+this->_size); i++)
				if(q.Mem(i))
					this->Add(i-m);
			

    }
  return *this;
}

BSet& BSet::AddNegation(const BSet p) // Extension this binary vector by adding its negation
{
  if (this != &p)
    {
      delete [] _elements;  

      Init(2*p._size, p._min);

      for (int i=0; i<p._inum; i++)
				_elements[i] = p._elements[i];

      for (int i=0; i<p._inum; i++)
				_elements[i] = ~p._elements[i];
    }


  _modflag = 1;

  return *this;
}


BSet& BSet::SetArray(int na, int* a, int& n)
	// Set the elements into an array a
{

  if ( Card() > na)
		{
			cerr << "Card > " << na << " .. cannot set the array due to size over" << endl;
			return *this;
		}
	else
		{
			n = 0;
			int c=0;
			int x;
			for (int i=0 ;i<_inum; i++)
				{ 
					WORD tmp = _elements[i];
					for (int j=ByteBound-1; j>=0; j--)
						{
							if ((tmp >> j) & 0x1)
								{
									x = c + _min;
									if (x < _max)
										a[n++] = x;
								}

							c++;
						}
				}
		}

	return *this;

}



BSet& BSet::SetBits(int na, int* a)
{
	AllSet(0);
	for (int i=0; i<na; i++)
		Add(a[i]);

  return *this;
}


