//       set.h
//
//       class Set <Abstract Class>... for operating several sets
//

#ifndef _Set
#define _Set

// #include <stdio.h>
#include <cstdio>
#include <cmath>
#include <cstring>

inline int min(int x, int y) { return ( x < y) ? x : y; };
inline int max(int x, int y) { return ( x >= y) ? x : y; };

const int DefaultSize = 100;
const int DefaultMax = 100;

extern int DefaultBSetSize;


typedef unsigned long long WORD;
//typedef int WORD;

const int WordSize  = sizeof(WORD);
const int ByteBound = sizeof(WORD) * 8;

class Set
{
public:
  Set(int size=DefaultSize, int min=0, int max=DefaultMax)
    { _size=size; _min=min; _max=max;};
  int Size(int s=0) { if (s > 0) _size = s; return _size; };
  int Min(int s=0) { if (s > 0) _min = s; return _min; };
  int Max(int s=0) { if (s > 0) _min = s; return _max; };
  virtual int Card(int )=0;
  virtual int Mem(int )=0;
  virtual int Add(int )=0;
  virtual int Empty(int )=0;
  virtual int Delete(int )=0;
  virtual void Print(char *, int , FILE *)=0;
  int Null() { return (_card == 0) ? 1: 0; };
  // virtual int operator <=( Set &)=0;  // 1 if this is a subset of A
  // virtual int operator <( Set &)=0;  // 1 if this is a strictly subset of A
  // virtual int operator >=( Set &)=0;  // 1 if this is a superset of A
  // virtual int operator >( Set &)=0;  // 1 if this is a superset of A
  // virtual int operator ==( Set &)=0;  // 1 if this is equal as A
  // virtual Set operator +( Set &)=0; // cup A
  // virtual Set operator *( Set &)=0; // cap A
  // virtual Set operator -( Set &)=0; // difference
  // virtual Set operator ^( Set &)=0; // extra or
  // virtual Set& operator +=( Set &)=0; // cup A
  // virtual Set& operator *=( Set &)=0; // cap A
  // virtual Set& operator -=( Set &)=0; // difference
  // virtual Set& operator ^=( Set &)=0; // extra or
protected:
  int _size;
  int _card;
  int _min;
  int _max;
};

class BSet:public Set  // Sets realized by bits
{
//  friend BList;
  friend class RGB_Region;
public:
	//  BSet() {Init(DefaultSize, 0);}
  BSet() {Init(DefaultBSetSize, 0);}
  BSet(int, int =0);
//  BSet(int =DefaultSize, int =0);
  BSet(const BSet& ); // copy constructor
  ~BSet();
  int AllSet(int i) { 
    if (i==1)
      { for(int i=0; i< _inum; i++) _elements[i] = ~0; _modflag = 0; _card =_top= _size;}
    else if(i==0)
      { for(int i=0; i< _inum; i++) _elements[i] = 0; _modflag = 0; _card=0; _top=0;}
    return 0;
  }
  int Card(int = 0);
  int Mem(int );
  int Add(int );
  int Empty(int =0);
  int Full();
  int Delete(int );
  BSet Complement();
  int Inum(int n=0) { if (n> 0) _inum = n; return _inum; }
  int Read(FILE * = stdin, int = 0);
  int Write(FILE * = stdout, int = 0);
  void Print(char* = "Bits Set",int = 0, FILE* = stdout);
  BSet& operator=(const BSet&);
  BSet& RangeCopy(BSet& p, int = 0, int = (-1));
  BSet& operator!=(const BSet& );
  int operator <=( BSet &);  // 1 if this is a subset of A
  int operator <( BSet &);  // 1 if this is a strictly subset of A
  int operator >=( BSet &);  // 1 if this is a superset of A
  int operator >( BSet &);  // 1 if this is a superset of A
  int operator ==( BSet &);  // 1 if this is equal as A
  BSet operator +( BSet &); // cup A
  BSet operator *( BSet &); // cap A
  BSet operator -( BSet &); // difference
  BSet operator ^( BSet &); // extra or
  BSet& operator +=( BSet &); // cup A
  BSet& operator *=( BSet &); // cap A
  BSet& operator -=( BSet &); // difference
  BSet& operator ^=( BSet &); // extra or
	BSet& operator~();  // Complement of A ... back to A
  BSet& AddNegation(const BSet p);
private:
//protected:
  BSet& SetArray(int, int*, int&);
  BSet& SetBits(int, int*);
  int SameDomain(BSet &, BSet &);
  int Init(int,  int );
  WORD *_elements;
  int _inum;
  int _modflag; // check modified or not for cardinality
  int _topten[10];
  int _top;
};

const int num_count = 16;

enum Kind_Count {create, copyc, insert, card, sunion, intersect, dest, mem, add, 
diff, sxor,setarray,Ldiff, Hdiff, Land, Hand};
extern int kcount[];
extern const char* namecount[];


#endif /* _Set */








